#!/bin/sh

ACTIVATE_REPORT_STATUS_CMD="/opt/agileacs/bin/agileacs_activate_report_ready.sh"
CEIP_REPORT_CMD="/opt/genieacs/bin/agileacs_activate_report.js update activation deployment"
ACTIVATE_REPORT_URL="Activation-AgileACS.TP-Link.com"
PING_RESULT_FILE="/tmp/ceip_check_ping_result"
CEIP_CHECK_RESULT_FILE="/tmp/ceip_check_result"

echo_result()
{
    #echo $@ 
    echo $@ >> $CEIP_CHECK_RESULT_FILE
}

stop_check()
{
    echo_result ""
    echo_result "Stop CEIP report checking"
    echo "$CEIP_CHECK_RESULT_FILE"
    exit
}

#0. clean result file
echo -n > $CEIP_CHECK_RESULT_FILE
now=$(date +'%Y-%m-%dT%T.%3NZ')
echo_result "CEIP report check [$now]"
echo_result ""
#1. check activation
activation_staus=$($ACTIVATE_REPORT_STATUS_CMD)
[ "$activation_staus" = "1" ] ||
{
    echo_result "1. Activation ...........[not complete]"
    stop_check
}
echo_result "1. Activation ...........[complete]"
echo_result ""
#2. ping Activation Report URL
ping -c 3 -w 3 $ACTIVATE_REPORT_URL > $PING_RESULT_FILE 2>&1 ||
{
    echo_result "2. $ACTIVATE_REPORT_URL Accessibility ...........[failed]"
    echo_result "--------------------------------------------------------------"
    cat $PING_RESULT_FILE >>  $CEIP_CHECK_RESULT_FILE
    echo_result "--------------------------------------------------------------"
    stop_check
}
echo_result "2. $ACTIVATE_REPORT_URL Accessibility ...........[succeed]"
echo_result ""
#3. send Activation Report 
ceip_staus=$($CEIP_REPORT_CMD)
[ "$ceip_staus" = "1" ] ||
{
    echo_result "3. Send CEIP Report ...........[failed]"
    echo_result "Please check downloaded log files for more detail information"
    stop_check
}
echo_result "3. Send CEIP Report ...........[succeed]"
echo_result ""
stop_check
exit