# !/bin/sh

DEBUG_FILE="/tmp/rrd_debug.log"
DEBUG_FLAG="/tmp/rrddbg"
RRD_FILE_PATH="/opt/agileacs/data/rrd"
CPU_RRD_FILE="$RRD_FILE_PATH/agileacs_sys_cpu.rrd"
MEMORY_RRD_FILE="$RRD_FILE_PATH/agileacs_sys_memory.rrd"
STORAGE_RRD_FILE="$RRD_FILE_PATH/agileacs_sys_storage.rrd"
STEP=60
HEARTBIT=120
ENTRY_DAY=266400 #1440*185


debug_print()
{
    [ -e $DEBUG_FLAG ] && echo $1 >>  $DEBUG_FILE
}

[ -e $RRD_FILE_PATH ] || mkdir -p $RRD_FILE_PATH

[ -e $CPU_RRD_FILE ] ||
{
debug_print "[`date`] rrdtool create $CPU_RRD_FILE -s $STEP DS:cpu:GAUGE:$HEARTBIT:0:100 RRA:AVERAGE:0.5:1:$ENTRY_DAY" >> $DEBUG_FILE
rrdtool create $CPU_RRD_FILE -s $STEP DS:cpu:GAUGE:$HEARTBIT:0:100 RRA:AVERAGE:0.5:1:$ENTRY_DAY
}

[ -e $MEMORY_RRD_FILE ] ||
{
debug_print "[`date`] rrdtool create $MEMORY_RRD_FILE -s $STEP DS:memory:GAUGE:$HEARTBIT:0:100 RRA:AVERAGE:0.5:1:$ENTRY_DAY " >> $DEBUG_FILE
rrdtool create $MEMORY_RRD_FILE -s $STEP DS:memory:GAUGE:$HEARTBIT:0:100 RRA:AVERAGE:0.5:1:$ENTRY_DAY
}

[ -e $STORAGE_RRD_FILE ] ||
{
debug_print "[`date`] rrdtool create $STORAGE_RRD_FILE -s $STEP DS:storage:GAUGE:$HEARTBIT:0:100  RRA:AVERAGE:0.5:1:$ENTRY_DAY " >> $DEBUG_FILE
rrdtool create $STORAGE_RRD_FILE -s $STEP DS:storage:GAUGE:$HEARTBIT:0:100  RRA:AVERAGE:0.5:1:$ENTRY_DAY
}
cpu_data=`/opt/agileacs/bin/getSystemUsage.sh cpu | sed 's/[^0-9]*//g'`
debug_print "[`date`] rrdtool update $CPU_RRD_FILE -t cpu N:$cpu_data " >> $DEBUG_FILE
rrdtool update $CPU_RRD_FILE -t cpu N:$cpu_data 
mem_data=`/opt/agileacs/bin/getSystemUsage.sh memory | awk -F "," '{print $3}' | awk -F "." '{print $1}'`
debug_print "[`date`] rrdtool update $MEMORY_RRD_FILE -t memory N:$mem_data " >> $DEBUG_FILE
rrdtool update $MEMORY_RRD_FILE -t memory N:$mem_data
storage_data=`/opt/agileacs/bin/getSystemUsage.sh storage| awk -F "," '{print $3}' | sed 's/[^0-9]*//g'`
debug_print "[`date`] rrdtool update $STORAGE_RRD_FILE -t storage N:$storage_data" >> $DEBUG_FILE
rrdtool update $STORAGE_RRD_FILE -t storage N:$storage_data
exit 0
