#!/bin/bash

FILE_FEATURE_SET_VERSION="/opt/agileacs/tmp/xj4j32l4ejvu045j6vup"

# return 1(enable), 0(disabled), -1(not support)
get_pro_enable() {
    /opt/agileacs/bin/acsutils2 license switch check >> /dev/null 2>&1
    
    if [ ! -f /opt/agileacs/tmp/xj4j32l4ejvu045j6vup ]; then
        echo "-2"
        exit 1
    fi
    
    feature_set_version=`cat $FILE_FEATURE_SET_VERSION`
    if [ "${feature_set_version}" != "lite" ] && [ "${feature_set_version}" != "pro" ] && [ "${feature_set_version}" != "pro-trial" ]; then
        echo "-1"
    else 
        if [ "${feature_set_version}" = "lite" ]; then
            echo "0"
        else 
            echo "1"
        fi
    fi
}


# main
pro_enable=$(get_pro_enable)
if [ "$pro_enable" != "1" ] && [ "$pro_enable" != "0" ]; then 
    if [ "$pro_enable" = "-2" ]; then
        echo "Can't find the feature set version"
    else
        echo "$FILE_FEATURE_SET_VERSION: {lite|pro-trial|pro}"
        echo "Unknown Feature Set Version: '$(cat $FILE_FEATURE_SET_VERSION)'"
    fi
    exit 1
fi

echo "pro_enable: ${pro_enable}"

files=`ls /opt/agileacs/bin/feature-set-switch/ | grep "_process_" | grep ".sh" | sort -n `
for file in $files
do 
	echo "File: $file"
	bash "/opt/agileacs/bin/feature-set-switch/$file" $pro_enable
done


