#!/bin/sh

action=$1
newhostip=$2
newsubnet=$3
newgateway=$4
newdns=$5
newhosturl=$6
newhttpport=$7
newhttpsport=$8
newacsusername=$9
newacspassword=$10
newcpeusername=$11
newcpepassword=$12
is_encrypt=$13

DEBUG_FILE="/var/log/genieacs/acsapps.log"
IFNAME="eth0"

echo "action($action) newhostip($newhostip) newsubnet($newsubnet) newgateway($newgateway) newdns($newdns) newhosturl($newhosturl) newhttpport($newhttpport) newhttpsport($newhttpsport) newacsusername($newacsusername) newacspassword($newacspassword) newcpeusername($newcpeusername) newcpepassword($newcpepassword)"
usage()
{
 echo "Usage: ./genieacs_update_system_setting_2.sh [add|remove] [newhostip] [newsubnet] [newgateway] [newdns] [newhosturl] [newhttpport] [newhttpsport] [newacsusername] [newacspassword] [newcpeusername] [newcpepassword]"
 exit 1
}

debug()
{
 date=`date +'%D %T'`
 echo "[$date][genieacs_update_system_setting_2.sh]$@" >> ${DEBUG_FILE}
}

fork_start()
{
	newhostip=$1
	newsubnet=$2
	newgateway=$3
	newdns=$4
	newhosturl=$5
	newhttpport=$6
	newhttpsport=$7
	newacsusername=$8
	newacspassword=$9
	newcpeusername=$10
	newcpepassword=$11
	is_encrypt=$12

	cp /opt/agileacs/etc/interface.sample /tmp/interfaces
	sed_strip="s/yourstaticip/${newhostip}/"
	sed -i  $sed_strip /tmp/interfaces
	sed_strsubnet="s/yourstaticsubnet/${newsubnet}/"
    sed -i  $sed_strsubnet /tmp/interfaces	
    sed_strgw="s/yourstaticgw/${newgateway}/"
    sed -i  $sed_strgw /tmp/interfaces
    sed_strdns="s/yourstaticdns/${newdns}/"
    sed -i  $sed_strdns /tmp/interfaces
	if cmp -s /tmp/interfaces /etc/network/interfaces; then
		debug  "interface setting is not changed"
	else
		debug "update interface  ip[($newhostip)] subnet[$newsubnet] gateway[$newgateway] dns[$newdns]"
	    /sbin/ifconfig ${IFNAME}:0 down
    	/sbin/ifconfig ${IFNAME} down
    	sleep 5
    	/sbin/ifconfig
    	/sbin/ifdown ${IFNAME}:0
    	/sbin/ifdown ${IFNAME}
    	mv /tmp/interfaces /etc/network/interfaces
    	/sbin/ifup ${IFNAME}
    	/sbin/ifup ${IFNAME}:0
		debug  "restart interface"
	fi

	debug "update nginx service ip[$newhostip] httpport[$newhttpport] httpsport[$newhttpsport]"
	cp /opt/agileacs/etc/nginx_sample_2.conf /tmp/nginx.conf
	sed_str1="s/nginxip/${newhostip}/"
	sed -i  $sed_str1 /tmp/nginx.conf
	sed_str2="s/ACS.yourdomian.com/${newhosturl}/"
	sed -i  $sed_str2 /tmp/nginx.conf
    sed_str3="s/httpport/${newhttpport}/"
    sed -i  $sed_str3 /tmp/nginx.conf
	/opt/agileacs/bin/genieacs_ufw_default.sh
	http_ufw=`ufw status verbose|grep ${newhttpport}/tcp |wc -l`
	[ $http_ufw = "2" ]  || {
		debug  "ufw allow ${newhttpport}/tcp"
		ufw allow ${newhttpport}/tcp
	}
    sed_str4="s/httpsport/${newhttpsport}/"
    sed -i  $sed_str4 /tmp/nginx.conf
	https_ufw=`ufw status verbose|grep ${newhttpsport}/tcp |wc -l`
	[ $https_ufw = "2" ] || {
		debug  "ufw allow ${newhttpsport}/tcp"
		ufw allow ${newhttpsport}/tcp
	}
	[ ${is_encrypt} = "1" ] && {
		newacsusername=`sudo /opt/agileacs/bin/acsutils2 decrypt ${newacsusername}`
	}
	[ ${is_encrypt} = "1" ] && {
		newacspassword=`sudo /opt/agileacs/bin/acsutils2 decrypt ${newacspassword}`
	}
	if [ ! "${newacsusername}" ] && [ ! "${newacspassword}" ]; then
		admin=`sudo /opt/agileacs/bin/acsutils2 encrypt admin`
		mongo tplink --eval 'db.syssetting.update({"_id":"cwmp"}, {$set: {"acs_username": "'$admin'", "acs_password": "'$admin'", "cpe_username": "'$admin'", "cpe_password": "'$admin'", "encrypt": 1}});'
		echo admin:$(openssl passwd -apr1 admin) > /tmp/ms-htpasswd
	else
		echo ${newacsusername}:$(openssl passwd -apr1 ${newacspassword}) > /tmp/ms-htpasswd
	fi
	mv /tmp/ms-htpasswd /etc/nginx/
	mv /tmp/nginx.conf /etc/nginx/
	/etc/init.d/nginx restart
	debug  "restart nginx"

	debug "update genieacs service url [($newhosturl)]"
	cp /opt/agileacs/etc/config-sample_2.json /tmp/config.json
	sed_str4="s/ACS.yourdomian.com/${newhosturl}/"
	sed -i  $sed_str4 /tmp/config.json
	debug "update genieacs service cpe username [($newcpeusername)] and password [($newcpepassword)]"
	sed_str5="s/cpe_username/${newcpeusername}/"
	sed -i  $sed_str5 /tmp/config.json
	sed_str6="s/cpe_password/${newcpepassword}/"
	sed -i  $sed_str6 /tmp/config.json
	mv  /tmp/config.json /opt/genieacs/config/config.json
	chown -R genieacs:www-data /opt/genieacs
	/etc/init.d/genieacs restart
	debug  "restart genieacs"
}


fork_stop()
{
	newhttpport=$1
	newhttpsport=$2
	debug "remove old service port from firewall ($newhttpport) ($newhttpsport)"
	[ "${newhttpport}" != "7547" ] && {
		ufw status verbose|grep "${newhttpport}/tcp" > /dev/null && {
			debug  "ufw delete allow ${newhttpport}/tcp"
			ufw delete allow ${newhttpport}/tcp
		}
	}
	[ "${newhttpsport}" != "7547" ] && {
		ufw status verbose|grep "${newhttpsport}/tcp" > /dev/null && {
			debug  "ufw delete allow ${newhttpsport}/tcp"
			ufw delete allow ${newhttpsport}/tcp
		}
	}
}

[ -z "${action}" ] && usage
[ -z "${newhostip}" ] && usage
[ -z "${newsubnet}" ] && usage
[ -z "${newgateway}" ] && usage
[ -z "${newdns}" ] && usage
[ -z "${newhosturl}" ] && usage
[ -z "${newhttpport}" ] && newhttpport="7547"
[ -z "${newhttpsport}" ] && newhttpsport="7548"
[ -z "${newacsusername}" ] && usage
[ -z "${newacspassword}" ] && usage
[ -z "${newcpeusername}" ] && usage
[ -z "${newcpepassword}" ] && usage
[ -z "${is_encrypt}" ] && usage

[ "${action}" = "add" ] &&  {
	fork_start ${newhostip} ${newsubnet} ${newgateway} ${newdns} ${newhosturl} ${newhttpport} ${newhttpsport} ${newacsusername} ${newacspassword} ${newcpeusername} ${newcpepassword} ${is_encrypt}&
}
[ "${action}" = "remove" ] && {
	fork_stop ${newhttpport} ${newhttpsport}&
}
exit


	

