#!/bin/sh

DEBUG_FILE="/var/log/genieacs/acsapps.log"
ZIP_PASSWORD="tplinkacs"
TMP_UPGRADE_FOLDER="/tmp/tmpupgrade"
UPGRADE_FILE=$1
TMP_UPGRADE_FILEINFO=$2
TMP_PREPROCESS_FILEINFO=$3
debug()
{
 date=`date +'%D %T'`
 echo "[$date]$@" >> ${DEBUG_FILE}
}

[ -z "${UPGRADE_FILE}" ] && {
	debug "Error: No Upgrade File assigned"
	exit 0
}
[ -e "${UPGRADE_FILE}" ] || {
	debug "Error: Upgrade File (${UPGRADE_FILE}) not exist"
	exit 0
}
[ -z "${TMP_UPGRADE_FILEINFO}" ] && {
	debug "Error: No Upgrade Info File assigned"
	exit 0
}

[ -e ${TMP_PREPROCESS_FILEINFO} ] && rm ${TMP_PREPROCESS_FILEINFO}

[ -e ${TMP_UPGRADE_FOLDER} ] && rm -rf ${TMP_UPGRADE_FOLDER}
mkdir ${TMP_UPGRADE_FOLDER}
unzip -P ${ZIP_PASSWORD} ${UPGRADE_FILE} -d ${TMP_UPGRADE_FOLDER} > /dev/null 2>&1 
[ -e ${TMP_UPGRADE_FOLDER} ] || {
	debug "Error: unzip ${UPGRADE_FILE} failed"
	exit 0
}
md5file="$(find ${TMP_UPGRADE_FOLDER} -name 'md5sum')"
debfile="$(find ${TMP_UPGRADE_FOLDER} -name '*.deb')"
prefile="$(find ${TMP_UPGRADE_FOLDER} -name '*.sh')"
[ -z ${debfile} ] && {
	debug "Error: No Upgrade DEB File Exist in ${UPGRADE_FILE}"
	exit 0
}
[ -n ${prefile} ] && [ -n ${TMP_PREPROCESS_FILEINFO} ] && {
	debug "echo \"$prefile\" > ${TMP_PREPROCESS_FILEINFO}"
	echo "$prefile" > ${TMP_PREPROCESS_FILEINFO}
}
md5file_sum="$(cat ${md5file} |awk '{print $1}')"
md5info_sum="$(md5sum ${debfile} |awk '{print $1}')"
if [ ${md5file_sum} = ${md5info_sum} ]; then
	echo "$debfile" > ${TMP_UPGRADE_FILEINFO}
	debug "MD5 Check Success"
	echo "success"
else
	debug "MD5 Check Not Match"
	echo "Error: MD5 Check Not Match"
fi
exit 1


