#!/bin/bash

partition_ver=$(mount | grep sda | wc -l)
get_df=""
if [ "$1" == "storage" ]; then
    if [ "$partition_ver" == "1" ]; then
        get_df=$(mount | grep sda | awk '{print $1}')
    else
        for line in $(mount | grep sda | awk '{print $3}')
        do
            if [ "$line" == "/var" ]; then
                get_df=$(mount | grep sda | grep $line | awk '{print $1}')
      fi
        done

        if [ "$get_df" == "" ]; then
        for line in $(mount | grep sda | awk '{print $3}')
        do
            if [ "$line" == "/" ]; then
                get_df=$(mount | grep sda | awk '{print $1}')
            fi
        done
        fi 
    fi

    # Caclulate mongoDB already allocate but not used storage size
    mongoGenieacsDataSize=$(mongo --quiet genieacs --eval 'db.stats().dataSize')
    mongoGenieacsIndexSize=$(mongo --quiet genieacs --eval 'db.stats().indexSize')
    mongoGenieacsFileSize=$(mongo --quiet genieacs --eval 'db.stats().fileSize')
    mongoTplinkDataSize=$(mongo --quiet tplink --eval 'db.stats().dataSize')
    mongoTplinkIndexSize=$(mongo --quiet genieacs --eval 'db.stats().indexSize')
    mongoTplinkFileSize=$(mongo --quiet tplink --eval 'db.stats().fileSize')
    mongoAllocateSize=$(($mongoGenieacsFileSize+$mongoTplinkFileSize))
    mongoActualSize=$(($mongoGenieacsDataSize+$mongoGenieacsIndexSize+$mongoTplinkDataSize+$mongoTplinkIndexSize))
    mongoNotUsedSize=$(($mongoAllocateSize-$mongoActualSize))
    mongoNotUsedSize=$(($mongoNotUsedSize/(1024*1024)))

    echo `df -m  $get_df | awk 'NR==2 {print $2","$3-'$mongoNotUsedSize'","$5}'`
elif [ "$1" == "cpu" ]; then
    # reference to Paul Colby (http://colby.id.au), no rights reserved ;)
    PREV_TOTAL=0
    PREV_IDLE=0
    
    for (( i=1; i<=2; i=i+1 ))
    do
        CPU=(`sed -n 's/^cpu\s//p' /proc/stat`)
        IDLE=${CPU[3]} # Just the idle CPU time.

        # Calculate the total CPU time.
        TOTAL=0
        for VALUE in "${CPU[@]}"; do
          let "TOTAL=$TOTAL+$VALUE"
        done

        # Calculate the CPU usage since we last checked.
        let "DIFF_IDLE=$IDLE-$PREV_IDLE"
        let "DIFF_TOTAL=$TOTAL-$PREV_TOTAL"
        let "DIFF_USAGE=(1000*($DIFF_TOTAL-$DIFF_IDLE)/$DIFF_TOTAL+5)/10"
        
        # Remember the total and idle CPU times for the next check.
        PREV_TOTAL="$TOTAL"
        PREV_IDLE="$IDLE"
        # Wait before checking again.
        sleep 1
    done
    echo "$DIFF_USAGE%"

    #echo `grep 'cpu ' /proc/stat | awk '{usage=($2+$4)*100/($2+$4+$5)} END {print usage "%"}'`
elif [ "$1" == "memory" ]; then
    echo `free | awk 'FNR == 2 {print $2-$7","$7","($2-$7)/$2*100 "%"}'`
    # unavalible , avalible , usage %
fi