#!/bin/bash

OP_LOG_FILE="/var/log/genieacs/acs-operation.log"
SYS_LOG_FILE="/var/log/genieacs/acs-system.log"

get_log_num() {
	RET_VAL=7
	case $1 in
		EMERGENCY)
			RET_VAL=0
			;;
		ALERT)
			RET_VAL=1
			;;
		CRITICAL)
			RET_VAL=2
			;;
		ERROR)
			RET_VAL=3
			;;
		WARN)
			RET_VAL=4
			;;
		NOTICE)
			RET_VAL=5
			;;
		INFO)
			RET_VAL=6
			;;
		DEBUG)
			RET_VAL=7
			;;
		*)
			RET_VAL=7
			;;
	esac
	echo $RET_VAL
}

op_log_msg() {
	TIME_STAMP=`date +"%Y-%m-%dT%T.%3NZ"`
	LOG_LEVEL=$1
	LOG_OBJ=$2
	LOG_CONTENT=$3
	LOG_NUM=$(get_log_num $LOG_LEVEL)

	echo "$TIME_STAMP [$LOG_LEVEL] $LOG_NUM 127.0.0.1 [$LOG_OBJ]: $LOG_CONTENT" >> $OP_LOG_FILE
}


sys_log_msg() {
	TIME_STAMP=`date +"%Y-%m-%dT%T.%3NZ"`
	LOG_LEVEL=$1
	LOG_OBJ=$2
	LOG_CONTENT=$3
	LOG_NUM=$(get_log_num $LOG_LEVEL)

	echo "$TIME_STAMP [$LOG_LEVEL] $LOG_NUM 127.0.0.1 [$LOG_OBJ]: $LOG_CONTENT" >> $SYS_LOG_FILE
}

#
# Sample code
# op_log_msg ERROR Backup_Restore "No USB flash drive"
#            ^^^^^ ^^^^^^^^^^^^^^ ^^^^^^^^^^^^^^^^^^^^
#            |     |              +------------------- LOG_CONTENT
#            |     +---------------------------------- LOG_OBJECT
#            +---------------------------------------- LOG_LEVEL
