#!/usr/bin/awk -f

#
# Parse output from command "lsblk -o model,name,fstype,size,label,RO,mountpoint -l"
#

function ltrim(s) { sub(/^[ \t\r\n]+/, "", s); return s }
function rtrim(s) { sub(/[ \t\r\n]+$/, "", s); return s }
function trim(s) { return rtrim(ltrim(s)) }

BEGIN {
	usb_count=1
	print "StorageNumber,USBStorage,Status,MountPoint,DevPath,FSType,Size,RO"
}
{
	if(NR>1) {
		if(match($NF, /media\/usb[0-9]/)) {
			split($0,a,/sd[a-z][0-9]*/);
			model_tmp=trim(a[1]);
			if(model_tmp != "") {
				model = model_tmp;
			}
			mount_point=$NF;
			ro=$(NF-1)
			label=$(NF-2)
			if( match(label, /[0-9\.]+G$/) ) {
				label=""
				size=$(NF-2)
				fstype=$(NF-3)
				devpath=$(NF-4)
			} else {
				size=$(NF-3)
				fstype=$(NF-4)
				devpath=$(NF-5)
			}

			#print usb_count","model" ["$4"] ("$3"),Ready,"$mount_point",/dev/"$1","$2","$3","$5
			if(label == "") {
				print usb_count","model" ("size"),Ready,"mount_point",/dev/"devpath","fstype","size","ro
			} else {
				print usb_count","model" ["label"] ("size"),Ready,"mount_point",/dev/"devpath","fstype","size","ro
			}

			mount_point="";
			model="";
			usb_count++;

		} else {
			if($NF != "[SWAP]" && $NF != "/" && $NF != "/var") {
				split($0,a,/sd[a-z][0-9]*/);
				model=trim(a[1]);
			}
		}
	} # if(NR>1)
}
#END {
#	print "Done"
#}
