#!/bin/bash

source /opt/agileacs/bin/usb-util.sh

show_usage() {
	pg_name=$1
	echo "$pg_name check - used to checking the USB status"
	echo "$pg_name get-list - get backup file list on USB"
	echo "$pg_name get-usage - get USB usage information"
}

if [ $# -eq 1 ]; then
	if [ "$1" == "check" ]; then
		usb_check

	elif [ "$1" == "get-list" ]; then
		usb_check

		cd $USB_MOUNT_POINT
		ls -al | grep "^-" | awk '{print NR" "$9" "$5}'
		exit 0

	elif [ "$1" == "get-usage" ]; then
		usb_check

		DEV_STATUS=`cat $USB_STATUS`
		if [ "$DEV_STATUS" == "Ready" ]; then
			USB_LIST=`lsblk -f | grep -i AgileACS | grep vfat`
			DEV_NAME=`echo $USB_LIST | awk '{print $1}'`
			DEV_NAME=`echo $DEV_NAME | sed -e "s/└//g" | sed -e "s/─//g"`
			RET=`df -m | grep "/dev/$DEV_NAME" | awk '{print "{\"usage\":\""substr($5,0,length($5))"\",\"used\":\""$3"\",\"available\":\""$4"\"}"}'`
			echo $RET
			exit 0
		else
			echo $DEV_STATUS
			exit 0
		fi
	else
		show_usage $0
	fi
elif [ $# -eq 2 ]; then
	if [ "$1" == "get-list" ]; then
		usb_check

		cd $2
		ls -al | grep "^-" | awk '{print NR" "$9" "$5}'
		exit 0
	fi
else
	show_usage $0
	exit 0
fi
