#!/bin/bash

#
# Since the usbmount utility cannot mount exFAT file system well. We use this mechanism for re-mount plugged USB storage
#

MONITORDIR="/tmp/acs_usbmount"
if [ ! -e $MONITORDIR ]; then
	mkdir -p $MONITORDIR
	chmod 666 $MONITORDIR
fi
echo "Monitor file change in directory [$MONITORDIR]"

inotifywait -m -r -e close_write --format '%f' "${MONITORDIR}" | while read MOUNT_USB
do
	if [ "$MOUNT_USB" != "" ]; then
		DEV=`awk '{print $1}' $MONITORDIR/$MOUNT_USB`
		MOUNTPOINT=`awk '{print $2}' $MONITORDIR/$MOUNT_USB`

		sleep 1
		umount $MOUNTPOINT

		sleep 1
		mount $DEV $MOUNTPOINT
		rm $MONITORDIR/$MOUNT_USB
	fi
done
