// Generated by CoffeeScript 1.9.3
(function () {
  var _MODELFORM, isRegex;

  _MODELFORM = 20;

  isRegex = function (input) {
    return /^\/(.*?)\/(g?i?m?y?)$/.test(input);
  };

  window.fadeOutAndRemove = function (el) {
    return $(el).fadeOut(200, function () {
      if ($(this).prev().text().match("and")) {
        $(this).prev().remove();
      } else {
        $(this).next().remove();
      }
      return $(this).remove();
    });
  };

  window.initFilters = function (id) {
    var container, container_selector, f, j, k, len, popup, query, recursive, ref, table, v;
    f = $("#" + id);
    table = "<div class=\"filter_items\">\n  <table class=\"filter_table\"></table>\n</div>";
    if ($(".filter_items").length === 0) {
      f.children('.filter_selection').after(table);
    }
    container_selector = "#" + id + " table";
    container = $(container_selector);
    recursive = function (query) {
      var op, q, results, v, v2;
      results = [];
      for (q in query) {
        v = query[q];
        if (q[0] === '$') {
          if (q !== '$and') {
            throw new Error("The logical operator " + q + " is not supported in precondition query.");
          }
          results.push((function () {
            var j, len, results1;
            results1 = [];
            for (j = 0, len = v.length; j < len; j++) {
              v2 = v[j];
              results1.push(recursive(v2));
            }
            return results1;
          })());
        } else if (v instanceof Object && q !== "_case_insensitive") {
          results.push((function () {
            var results1;
            results1 = [];
            for (op in v) {
              v2 = v[op];
              results1.push(addFilter(container, q, op, v2, false));
            }
            return results1;
          })());
        } else {
          if (q !== "_case_insensitive") {
            results.push(addFilter(container, q, '=', v, false));
          } else {
            results.push(void 0);
          }
        }
      }
      return results;
    };
    if (container.children().length === 0) {
      query = JSON.parse(f.children('input[name=query]').attr('value'));
      recursive(query);
      if (query["_case_insensitive"] !== void 0 && query["_case_insensitive"].length > 0) {
        ref = query["_case_insensitive"];
        for (j = 0, len = ref.length; j < len; j++) {
          k = ref[j];
          $("td[name='" + k + "']").parent().find("td[_name=ci]").text("(Case Insensitive)");
        }
      }
    }
    popup = "<div class='filter'>\n  <div>\n    <select id=\"items\">\n    ";
    for (k in filters) {
      v = filters[k];
      popup += "<option value='" + k + "'>" + v + "</option>";
    }
    popup += "</select>\n  </div>\n  <div>\n    <select id=\"operation\">\n    </select>\n  </div>\n  <div id=\"input_type\">\n    <input id='value_' type='text' required>\n  </div>\n  <div id='send'>\n    <i class='fa fa-check-circle-o fa-lg check' style=\"font-size: 23px;padding-left: 10px;\" onclick=\"addFilter('" + container_selector + "','','','',true);\"></i>\n  </div>\n  <div class=\"warning\" style=\"display:none\">\n    <i class='fa fa-exclamation-triangle fa-lg warning_msg' style=\"font-size: 23px;padding-left: 10px;\" title=\"Operation already existed.Please choose other operation.\"></i>\n  </div>\n  </div>";
    f.children('.filter_selection').html(popup);
    init_list();
    checkExist();
    check_op_case_insensitive();
    $("#items").change(function () {
      checkExist();
      check_op_case_insensitive();
      return init_list();
    });
    $("#operation").change(function () {
      checkExist();
      return check_op_case_insensitive();
    });
    return $("body").on("click", ".remove", function () {
      $(this).parent().parent().fadeOut(300, $(this).parent().parent().remove());
      checkExist();
      return check_op_case_insensitive();
    });
  };

  window.init_list = function (value) {
    var arr_apps, arr_models, el, html, i, model_column, model_width, name, op;
    if (value == null) {
      value = '';
    }
    name = $("#items option:selected").val();
    op = $("#operation option:selected").text();
    if (!name) {
      return;
    }
    $("#input_type").empty();
    $("#operation").empty();
    if (name.match(/model/i)) {
      html = "<select id='selectValue' style='width: 150px;'>";
      arr_models = JSON.parse($('#modelsAll').val());
      i = 0;
      while (i < arr_models.length) {
        if (i === _MODELFORM) {
          html += " <optgroup> ";
        } else if (i !== _MODELFORM && i % _MODELFORM === 0) {
          html += " </optgroup> ";
          html += " <optgroup> ";
        }
        if (value !== arr_models[i]) {
          html += " <option value=\"" + arr_models[i] + "\">" + arr_models[i] + "</options> ";
        } else {
          html += " <option selected=\"selected\" value=\"" + arr_models[i] + "\">" + arr_models[i] + "</options> ";
        }
        i++;
      }
      html += "</select>";
    } else if (name.match(/app/i)) {
      html = "<select id='selectValue'>";
      arr_apps = JSON.parse($('#apps').val());
      i = 0;
      while (i < arr_apps.length) {
        html += " <option value=\"" + arr_apps[i] + "\">" + arr_apps[i] + "</options> ";
        i++;
      }
      html += "</select>";
    } else if (name.match(/type/i)) {
      html = "<select id='selectValue'>\n  <option value=\"1 Firmware Upgrade Image\">1 Firmware Upgrade Image</option>\n  <option value=\"3 Vendor Configuration File\">3 Vendor Configuration File</option>\n</select>";
    } else if (name.match(/mac/i)) {
      html = "<input id='value_' type='text' placeholder='XX:XX:XX:XX:XX:XX' pattern='^(([A-Fa-f0-9]{2}[:]){5}[A-Fa-f0-9]{2}[,]?)+$' required>";
      html += addCaseInsensitiveCheckbox();
    } else if (name.match(/ip/i)) {
      html = "<input id='value_' type='text' placeholder='0.0.0.0' pattern='^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$' required>";
    } else if (name.match(/homeid/i) || name.match(/zoneid/i) || name.match(/cellphone/i) || name.match(/cpf/i)) {
      html = "<input id='value_' type='text' placeholder='blank' pattern=\"(^.{0,0}$|^[\\(\\)#/\\.\\w@-]$|^[\\(\\)#/\\.\\w@-][\\(\\)#/\\.\\w@ -]*[\\(\\)#/\\.\\w@-]$)\" maxlength=\"32\">";
      html += addCaseInsensitiveCheckbox();
    } else if (name.match(/lastinform/i)) {
      html = "<input class=\"lastInform\" id=\"value_\" type=\"text\" required/>";
    } else if (name.match(/_id/i)) {
      html = "<input id='value_' type='text' pattern='[A-Za-z0-9_]+' title='Name should only contain character or underline.' required>";
      html += addCaseInsensitiveCheckbox();
    } else {
      html = "<input id='value_' type='text' required>";
      html += addCaseInsensitiveCheckbox();
    }
    if (name.match(/model/i) || name.match(/sw/i) || name.match(/hw/i) || name.match(/app/i) || name.match(/type/i)) {
      el = "<option value=\"\" >=</option>\n<option value=\"$ne\">&ne;</option>";
    } else {
      el = "<option value=\"\">=</option>\n<option value=\"$ne\">&ne;</option>\n<option value=\"$lt\">&lt;</option>\n<option value=\"$lte\">&le;</option>\n<option value=\"$gt\">&gt;</option>\n<option value=\"$gte\">&ge;</option>";
    }
    $("#operation").append(el);
    $("#input_type").append(html);
    if (name.match(/model/i)) {
      arr_models = JSON.parse($('#modelsAll').val());
      model_column = parseInt(arr_models.length / _MODELFORM) + 1;
      model_width = model_column * 150;
      $('#selectValue').css('width', model_width + 'px');
      $('.select2-results-dept-0').css('width', model_width / model_column);
      return $('#selectValue').select2({
        placeholder: "Select",
        theme: "classic",
        formatResult: function (m) {
          return m.text;
        },
        formatSelection: function (m) {
          return m.text;
        },
        escapeMarkup: function (m) {
          return m;
        }
      });
    } else if (name.match(/lastinform/i)) {
      return $('.lastInform').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        timePicker: true,
        timePicker24Hour: true,
        timePickerIncrement: 1,
        startDate: local_time,
        locale: {
          format: 'YYYY-MM-DD HH:mm:ss'
        }
      });
    }
  };

  window.checkExist = function () {
    var name, op;
    name = $("#items option:selected").text();
    op = $("#operation option:selected").text();
    if (check_op_existed(name, op)) {
      $("#send").hide();
      return $(".warning").show();
    } else {
      $("#send").show();
      return $(".warning").hide();
    }
  };

  window.check_op_case_insensitive = function () {
    var op;
    $("#case_insensitive_").prop("checked", false);
    op = $("#operation option:selected").text();
    if ($("#case_insensitive_").length) {
      if (op === "=") {
        $("#case_insensitive_").show();
        return $("#label_case_insensitive_").show();
      } else {
        $("#case_insensitive_").hide();
        return $("#label_case_insensitive_").hide();
      }
    } else {
      $("#case_insensitive_").hide();
      return $("#label_case_insensitive_").hide();
    }
  };

  window.check_op_existed = function (name, op) {
    var res;
    res = false;
    $("table.filter_table td:contains(" + name + "):visible").each(function () {
      if ($(this).next().text() === op) {
        $("#opration").focus();
        return res = true;
      }
    });
    return res;
  };

  window.updateFilters = function (id) {
    var case_insensitive, i, j, l, len, len1, len2, n, name, o, op, p, params, q, query, ref, s, useAnd, value;
    query = {};
    params = {};
    case_insensitive = [];
    $("#" + id + " .filter_table tr").each(function () {
      var ip, ip_part, j, len, name, op, v, value;
      if ($(this).children('[_name=name]').length) {
        name = $(this).children('[_name=name]').attr('name').trim();
        op = $(this).children('[_name="op"]').attr('op').trim();
        value = $(this).children('[_name="value"]').text().trim();
        if ($(this).children('[_name="valuePro"]').length) {
          value = $(this).children('[_name="valuePro"]').text().trim();
        }
        if ($(this).children('[_name="ci"]').text() !== "") {
          case_insensitive.push(name);
        }
        if (name === "IP") {
          ip_part = value.split(".");
          ip = [];
          for (j = 0, len = ip_part.length; j < len; j++) {
            v = ip_part[j];
            ip.push(v.padStart(3, "0"));
          }
          value = ip.join(".");
        }
        if (params[name]) {
          return params[name].push([op, value]);
        } else {
          return params[name] = [[op, value]];
        }
      }
    });
    for (name in params) {
      p = params[name];
      if (p.length > 1) {
        useAnd = true;
        p.sort();
        for (i = j = 0, len = p.length; j < len; i = ++j) {
          s = p[i];
          if (s[0] === '' || s[0] === ((ref = p[i - 1]) != null ? ref[0] : void 0)) {
            useAnd = true;
            break;
          }
        }
        if (useAnd) {
          if (query['$and'] == null) {
            query['$and'] = [];
          }
          for (l = 0, len1 = p.length; l < len1; l++) {
            s = p[l];
            o = {};
            op = s[0];
            value = s[1];
            if (op === '') {
              o[name] = value;
            } else {
              o[name] = {};
              o[name][op] = value;
            }
            query['$and'].push(o);
          }
        } else {
          o = {};
          for (n = 0, len2 = p.length; n < len2; n++) {
            s = p[n];
            op = s[0];
            value = s[1];
            o[op] = value;
          }
          query[name] = o;
        }
      } else {
        op = p[0][0];
        value = p[0][1];
        if (op !== '') {
          q = {};
          q[op] = value;
          query[name] = q;
        } else {
          query[name] = value;
        }
      }
    }
    if (case_insensitive !== void 0 && case_insensitive.length > 0) {
      query["_case_insensitive"] = case_insensitive;
    }
    $("#" + id + " > input[name=query]").attr('value', JSON.stringify(query));
    if ($("#" + id + " > input[name=sort]").attr('value') === '') {
      return $("#" + id + " > input[name=sort]").attr('disabled', 'disabled');
    } else {
      return $("#" + id + " > input[name=sort]").removeAttr('disabled');
    }
  };

  window.removeRequired = function () {
    return $("#value_").removeAttr("required");
  };

  window.addFilter = function (container, name, op, value, fade) {
    var ci, el, html, ip, ip_arr, item, j, label, len, op_, type, v, val;
    if (name == null) {
      name = "";
    }
    if (op == null) {
      op = "";
    }
    if (value == null) {
      value = "";
    }
    if ($("#input_type").length !== 0) {
      switch ($("#items option:selected").html()) {
        case "Model":
          if (!$("#input_type").children()[1].reportValidity()) {
            return;
          }
          break;
        default:
          if (!$("#input_type").children()[0].reportValidity()) {
            return;
          }
      }
    }
    type = typeof value;
    if (filters[name]) {
      label = filters[name];
    } else {
      label = name.replace(/^_/, "");
    }
    item = label === "" ? $("#items option:selected").text() : label;
    name = name === "" ? $("#items").val() : name;
    if (op === "") {
      op = $("#operation option:selected").text();
      op_ = $("#operation option:selected").val();
    } else {
      op_ = op === "=" ? "" : op;
      if (op === "$lte") {
        op = "&le;";
      } else if (op === "$gte") {
        op = "&ge;";
      } else if (op === "$ne") {
        op = "&ne;";
      } else if ((op === "$gt") || (op === "$lt")) {
        op = op.replace('$', '&') + ";";
      }
    }
    if (check_op_existed(item, op)) {
      return;
    }
    if (value === '') {
      val = $("#value_").val() ? $("#value_").val() : $("#selectValue").val();
    } else {
      val = value;
    }
    if (!val) {
      val = '';
    }
    if (name === 'IP') {
      ip_arr = val.split(".");
      ip = [];
      for (j = 0, len = ip_arr.length; j < len; j++) {
        v = ip_arr[j];
        ip.push(Number(v));
      }
      val = ip.join(".");
    }
    ci = "";
    if ($("#case_insensitive_").length && $("#case_insensitive_:checked").length > 0) {
      ci = "(Case Insensitive)";
    }
    if (val !== '') {
      html = "<tr>\n  <td _name='name' name=" + name + " >" + item + "</td>\n  <td _name='op' op=" + op_ + " >" + op + "</td>\n  <td _name='value'>" + val + "</td>\n  <td _name='ci'>" + ci + "</td>\n  <td><i class='fa fa-minus-circle fa-lg remove'></i></td>\n</tr>";
    } else {
      html = "<tr>\n  <td _name='name' name=" + name + " >" + item + "</td>\n  <td _name='op' op=" + op_ + " >" + op + "</td>\n  <td _name='value'><span class=\"long-text param-value\"></span></td>\n  <td _name='ci'>" + ci + "</td>\n  <td><i class='fa fa-minus-circle fa-lg remove'></i></td>\n</tr>";
    }
    el = $(html);
    $(container).append(el);
    init_select($("div.filter_selection select"), $("div.filter_selection input"));
    if ($("div.filter_selection").children().length > 0) {
      checkExist();
      check_op_case_insensitive();
    }
    init_list();
    if (fade) {
      return el.hide().fadeIn(300);
    }
  };

  window.init_select = function (select, value) {
    select.each(function () {
      return $(this).prop('selectedIndex', 0);
    });
    return value.val("");
  };

  window.addCaseInsensitiveCheckbox = function () {
    var regex_profile_edit, regex_profile_new, url;
    url = window.location.href;
    regex_profile_new = new RegExp("/profiles/new");
    regex_profile_edit = new RegExp("/profiles/[A-Za-z0-9_-]+/edit");
    if (regex_profile_new.test(url) || regex_profile_edit.test(url)) {
      return "";
    } else {
      return "<input id='case_insensitive_' type='checkbox'><label id='label_case_insensitive_' for='case_insensitive_'>Case Insensitive</label>";
    }
  };

}).call(this);
