// Generated by CoffeeScript 1.9.3
(function() {
  var getLongText, selectText, showLongText;

  selectText = function(container) {
    var range;
    if (document.selection) {
      range = document.body.createTextRange();
      range.moveToElementText(container);
      return range.select();
    } else if (window.getSelection) {
      range = document.createRange();
      range.selectNodeContents(container);
      return window.getSelection().addRange(range);
    }
  };

  getLongText = function(container) {
    if (!container.hasClass('long-text-always') && container.outerWidth() === container[0].scrollWidth || container[0].scrollWidth === 0) {
      return null;
    }
    return container.text();
  };

  showLongText = function(text) {
    var buttons, close, modal, modalWrapper, valueContainer;
    modalWrapper = $('<div class="modal-wrapper"></div>');
    $('body').append(modalWrapper);
    modal = $('<div class="modal long-value-modal"></div>');
    modalWrapper.append(modal);
    valueContainer = $("<textarea readonly=\"readonly\" cols=80>" + text + "</textarea>");
    modal.append(valueContainer);
    buttons = $('<div class="buttons"></div>');
    modal.append(buttons);
    close = $('<a href="#">Close</a>').click(function() {
      modalWrapper.remove();
      return false;
    });
    buttons.append(close);
    valueContainer.focus();
    return valueContainer.select();
  };

  $(document).keydown(function(e) {
    if (e.keyCode === 27) {
      return $('.modal-wrapper').remove();
    }
  });

  $(document).on('mousedown', '.long-text, .long-text-always', null, function(event) {
    var handler, longText;
    longText = getLongText($(this));
    if (longText) {
      event.stopPropagation();
    }
    return $(document).on('mouseup mousemove', '.long-text, .long-text-always', null, handler = function(event) {
      $(document).off('mouseup mousemove', '.long-text, .long-text-always', handler);
      if (event.type === 'mouseup') {
        if (longText) {
          return showLongText(longText);
        } else {
          return selectText(this);
        }
      }
    });
  });

  $(document).on('click', '.modal-wrapper', null, function(e) {
    if (e.target !== this) {
      return false;
    }
    return $(this).remove();
  });

}).call(this);
