# ChangePasswordController
class ChangePasswordController < ApplicationController
  include Loggers
  include Util
  def index; end

  def update
    user = User.find_by username: params['username']
    unless user
      log_message(3, 'Incorrect username or password', 'Change password failed. Incorrect username or password.')
      return
    end

    if user['password'] != params['old_password']
      log_message(3, 'Incorrect username or password', 'Change password failed. Incorrect username or password.')
      return
    end

    unless user.update(password: params['new_password'])
      log_message(3, user.errors.full_messages.join('; '), "Change password failed. #{user.errors.full_messages.join('; ')}")
      return
    end

    log_message(6, 'Password successfully changed', 'Change password succeed.')
    redirect_to log_out_path
  end

  def log_message(levelnum, msg, acs_log)
    object = '[Account Change]'
    task = { 'levelnum' => levelnum, 'user' => params['username'] }
    http = create_api_conn()
    flash[:error] = msg if levelnum == 3
    flash[:success] = msg if levelnum == 6
    agileACSLog(levelnum, object, acs_log)
    http.post('/sessions/change_password_counts', ActiveSupport::JSON.encode(task), 'Content-Type' => 'application/json')
    redirect_to change_password_path unless levelnum == 6
  end
end
