# Log Controller for log page
class LogController < ApplicationController
  require 'csv'
  include Log
  include Loggers
  def index
    if request.url.match(/.tar$/)
      can?(:update, 'log') do
        index_tar()
        return
      end
    else
      can?(:read, 'log') do
        get_log()
      end
    end
  end

  def export_csv
    can?(:update, 'log') do
      export()
    end
  end

  def destroy
    can?(:delete, 'log') do
      delete_file_path = "/var/log/genieacs/#{CGI.escape(params[:id])}"
      `echo "" > #{delete_file_path}`
      `rm -f #{delete_file_path}.*`
      redirect_to action: :index
      agileACSLog(6, '[Clean Log]', "#{CGI.escape(params[:id])} clean log succeed.")
    end
  end

  private

  def index_tar
    path = acsapps_debug
    if path.blank?
      redirect_to log_path
    else
      send_file path
    end
    agileACSLog(6, '[Download Log]', 'Download log succeed.')
  end

  def acsapps_debug
    http = create_api_conn()
    data = {}
    data['action'] = 'log'
    res = http.put('/log/acsapps', ActiveSupport::JSON.encode(data), 'Content-type' => 'application/json')

    if res.code == '200'
      res.body
    else
      flash[:error] = "Unexpected error (#{res.code}): #{res.body}"
      nil
    end
  end
end
