class ModelEditController < ApplicationController
    require 'loggers'
    require 'models'
    def index
        can?(:read, 'model_edit') do
            res = query_resource(create_api_conn(), 'model', nil)
            @models = res[:result]
            @modelsAll = []
            @models.each do |model|
                @modelsAll << model['_id']
            end
            @modelsAll = @modelsAll.sort
        end
    end

    def new
        can?(:create, 'model_edit') do
            object = "[Model Create]"
            modelName = params[:name].strip
            if  modelName != ""
                http = create_api_conn()
                res = query_resource(http, 'model', nil)
                @models = res[:result]
                if !@models.find { |model| model['_id'] == modelName }
                    res = http.put("/model/#{URI.escape(params[:name].strip)}", nil)
                    if res.code == '200'
                        flash[:success] = "Model #{modelName} created"
                        agileACSLog(6, object, "Create model #{modelName} succeed.")
                    else
                        flash[:error] = "Unexpected error (#{res.code}): #{res.body}"
                        agileACSLog(3, object, "Unexpected error (#{res.code}): #{res.body}")
                    end
                else
                    flash[:warning] = "Model #{modelName} is already created "
                    agileACSLog(4, object, "Model #{modelName} is already created. ")
                end
                
            else
                flash[:warning] = "Please enter a Model name."
            end
            redirect_to :action => :index
        end
    end

    def delete
        can?(:delete, 'model_edit') do
            object = "[Model Destroy]"
            http = create_api_conn()
            if is_model_used_by_profiles(params['model'])
                flash[:error] = "Sorry, the #{params['model']} is already used in the profile, please remove the related profiles in advance."
                agileACSLog(3, object, "The #{params['model']} is already used in the profile, please remove the related profiles in advance.")
            else
                if is_model_used_by_files(params['model'])
                    flash[:error] = "Sorry, the #{params['model']} is already used in the file, please remove the related files in advance."
                    agileACSLog(3, object, "The #{params['model']} is already used in the file, please remove the related files in advance.")
                else
                    res = http.delete("/model/#{URI.escape(params['model'])}", nil)
                    if res.code == '200'
                        flash[:success] = "Model #{params['model']} deleted"
                        agileACSLog(6, object, "Destroy model #{params['model']} succeed.")
                    else
                        flash[:error] = "Unexpected error (#{res.code}): #{res.body}"
                        agileACSLog(3, object, "Unexpected error (#{res.code}): #{res.body}")
                    end
                end
            end
            redirect_to :action => :index
        end
    end
end
