# controller for /notifications
class NotificationsController < ApplicationController
  include Loggers
  include NotificationsModule
  def index
    can?(:read, 'notifications') do
      params['tab'] = 'mail' unless params.include? 'tab'
      @result = get_info_by(params['tab'])
    end
  end

  def create
    can?(:update, 'notifications') do
      url = '/notification/mail'
      params['tab'] = 'mail' unless params.include? 'tab'

      if params['tab'] == 'task'
        task = params.except('authenticity_token')
        data = generate_task_data(task)
      else
        mail_settings = { 'username' => '', 'password' => '', 'smtp_server' => '', 'port' => '' }
        mail_settings['service'] = params['service']
        mail_settings['from'] = params['from']
        mail_settings['to'] = params['to']
        mail_settings['subject_prefix'] = params['subject_prefix']
        optional_mail_settings(mail_settings)
        data = { 'settings' => mail_settings }
        url = '/notification/test' if params.include?('test')
      end
      send_notifications_request(url, data)
    end
  end
end
