class PingController < ApplicationController
  include Loggers

  def index  
    require 'net/http'
    require 'util'
    http = create_api_conn()
    res = http.send_request(request.method, "/ping/#{params[:ip]}", nil)

    self.response.status = res.code
    res.each_header { |key,value|
      self.response.headers[key] = value
    }
    self.response.headers.delete('transfer-encoding')
    self.response.headers['Content-Type'] = res['Content-Type']

    self.response_body = res.body
    object = "[Device Detail][Ping]#{params[:id]}"
    if res.code == '200'
      agileACSLog(6, object, "Ping #{res.message}")
    elsif res.code == '202'
      agileACSLog(4, object, "#{res.message}")
    else
      agileACSLog(3, object, "Unexpected error (#{res.code}): #{res.body}")
    end
  end
end
