class PrefaceController < ApplicationController
    layout "preface"
    def index
        can?(:read,'preface') do
            @country = Rails.configuration.country
            res = query_resource(create_api_conn(), 'activateReport', nil)
            if res[:result].size == 1
                @ceip = res[:result][0]
            else
                @ceip = {}
            end
        end
    end

    def save_info
        can?(:update,'preface') do
            http = create_api_conn()
            data = {
                "wisp_region" => params[:region],
                "wisp_country"=> params[:country],
                "wisp_name" => params[:name],
                "wisp_email" => params[:email],
                "wisp_cnpj" => params[:cnpj]
            }
            res = http.post("/activateReport/save_info",ActiveSupport::JSON.encode(data), 'Content-type' => 'application/json')
            
            if res.code == '200'
                msg = {"msg" => "success"} 
            else
                msg = {"msg" => "fail"}
            end
        
            render :json => msg
        end
    end

    def check_network
        can?(:update,'preface') do
            @ceip = index()
            if @ceip['status'] == 'activated'
                msg = {"msg" => "success"} 
            else
                http = create_api_conn()       
                res = http.post("/activateReport/check_network",nil)
                msg = res.body
            end
            render :json => msg
        end
    end
end
