class PrivilegesController < ApplicationController
  def update
    can?(:update, 'roles') do
      begin
        return if params[:role_id] == 0
        if params.has_key?'restore'
          reset_to_default(params[:role_id])
        end

        if params.has_key?'create'
          params[:create].each do |k,v|
            create_privilege(v[:resource],v[:action],v[:role_id])
          end
        end
        
        if params.has_key?'remove'
          params[:remove].each do |k,v|
            delete_privilege(v[:resource],v[:action],v[:role_id])
          end
        end
        $db_change = true
        flash[:success] = "Success"
        #if new entry; create
        #if old entry; update
        # redirect_to edit_role_path(@role)
      rescue => exception
        flash[:error] = "Unexpected error"
      end
    end
  end

  private
  def reset_to_default(role_id)
    role = Role.find(role_id)
    role.privileges.where('role_id = ? ', role_id).destroy_all
  end

  def create_privilege(resource,action,role_id)  
    @role = Role.find(role_id)
    set_exist(resource,role_id)

    privilege = Privilege.new
    privilege.resource = resource
    privilege.action = action
    privilege.weight = 1
    @role.privileges << privilege
    privilege.save
  end

  def delete_privilege(resource,action,role_id)
    @role = Role.find(role_id)
    set_exist(resource,role_id)
    @role.privileges
    @role.privileges.where('resource = ? AND action = ?', resource, action).destroy_all
  end

  def set_exist(resource,role_id)
    #"exist" means user has changed
    exist = Privilege.where('resource = ? AND action = ? AND role_id = ? ', resource, "exist",role_id)
    if exist.blank?
      privilege_exist = Privilege.new
      privilege_exist.resource = resource
      privilege_exist.action = "exist"
      privilege_exist.weight = 1
      privilege_exist.role_id = role_id
      privilege_exist.save
    end
  end
end
