class UserRolesController < ApplicationController
  
  def create
    can?(:create, 'roles') do
      @user = User.find(params[:user_id])
      @user_role = @user.user_roles.find_by(:user_id => @user.id)
      @user_role = @user.user_roles.new if @user_role.nil?
      @user_role.role_id = params[:user_role][:role_id]

      @user_role.save
      $db_change = true
      flash[:success] = "Success"
      redirect_to edit_user_path(@user)
    end
  end
  
  def destroy
    can?(:delete, 'roles') do
      @user = User.find(params[:user_id])
      @user_role = @user.user_roles.find(params['id'])
      @user_role.destroy
      $db_change = true
      redirect_to edit_user_path(@user)
    end
  end

  private
    def user_role_params
      params.require(:user_role).permit(:user_id, :role_id)
    end
end
