module DevicesHelper
  def get_param(path, device)
    #return device[path] if device.has_key?(path)

    ref = device
    nodes = path.split('.')
    pp = []
    for node in nodes
      pp << node
      p = pp.join('.')

      if ref.has_key?(p)
        ref = ref[p]
        pp = []
      end
    end
    if not pp.empty?
      return nil
    end
    return ref
  end

  def convert_to_mesh(convert_str)
    if convert_str.nil? or convert_str.empty?
      return "N/A"
    end
    return convert_str
  end

  def convert_to_xmpp_status_enabled(convert_str)
    if convert_str.blank?
      return "-"
    end
    ret = convert_str
    case (convert_str)
    when "Enabled", "Connecting"
      ret = "on"
    else
      ret = "off"
    end
    return ret
  end

  def convert_to_xmpp_status(convert_str)
    if convert_str.blank? or convert_str.empty?
      return "no"
    end
    return "yes"
  end

  def convert_to_ip(convert_str)
    if convert_str.nil?
      return '-'
    end
    value = convert_str
    replaced_str = value.to_s.match(/>[\w\W\d\.:]+</)
    value = value.gsub(replaced_str.to_s, ">" + extract_ip(value) + "<").html_safe
    return value
  end

  def extract_ip(url)
    url = url.to_s.match(/\d+\.\d+\.\d+\.\d+/).to_s
    ip_arr = url.split(".")
    ip_arr_no_zero = []
    ip_arr.each do |i|
       ip_arr_no_zero.push(i.to_i)
    end 
    return ip_arr_no_zero.join(".")
  end
  
  def param_value(path, device)
    classes = ['long-text', 'param-value']

    param = get_param(path, device)
    return nil if param == nil
    return param['_value'] if path.include?("XMPP.Connection.1.Status")

    if param.is_a?(Hash)
      val = param.include?('_orig')? param['_orig'] : param['_value']
      if param.include? '_timestamp'
        tooltip = 'title="as of ' + distance_of_time_in_words(@now, param['_timestamp'], include_seconds: true) + ' ago"'
      end
      classes << 'value-writable' if param['_writable']
    else
      val = param
    end

    if param['_type'] == 'xsd:dateTime' && !param['_path'].start_with?("Device.", "InternetGatewayDevice.")
      val = val.to_time.localtime.strftime('%FT%T.%3NZ')
    end

    valHtml = CGI::escapeHTML(val.to_s)
    bare_path = path.gsub(/\.\d+\./, '..')
    if Rails.configuration.parameter_renderers.has_key?(bare_path)
      begin
        valHtml = ParameterRenderers::send(Rails.configuration.parameter_renderers[bare_path], val)
      rescue => e
        logger.error("Exception in renderer '#{Rails.configuration.parameter_renderers[path]}' for value '#{val}': #{e}")
      end
    end

    if not classes.empty?
      cls = 'class="' + classes.join(' ') + '"'
    end

    "<span #{cls} #{tooltip}>#{valHtml}</span>".html_safe
  end

  
  def convert_valHtml(val, append_class = nil)
    return nil if val == nil

    classes = ['long-text', 'param-value']
    classes << append_class if not append_class.blank?

    valHtml = CGI::escapeHTML(val.to_s)

    if not classes.empty?
      cls = 'class="' + classes.join(' ') + '"'
    end
    "<span #{cls}>#{valHtml}</span>".html_safe
  end
  
  def convert_valHtml_ext(val, append_class = nil)
    return nil if val == nil

    classes = ['long-text', 'param-value']
    classes << append_class if not append_class.blank?

    if not classes.empty?
      cls = 'class="' + classes.join(' ') + '"'
    end

    "<span #{cls} title='#{val.to_s}'>#{val}</span>".html_safe
  end


end
