# Need to not fail when uri contains curly braces
# This overrides the DEFAULT_PARSER with the UNRESERVED key, including '{' and '}'
# DEFAULT_PARSER is used everywhere, so its better to override it once
module URI
  remove_const :DEFAULT_PARSER
  unreserved = REGEXP::PATTERN::UNRESERVED
  DEFAULT_PARSER = Parser.new(UNRESERVED: unreserved + "\{\}\^")
end

GenieacsGui::Application.routes.draw do
  root 'preface#index'
  get 'preface/get_info' => 'preface#get_info'
  post 'preface/check_network' => 'preface#check_network'
  post 'preface/save_info' => 'preface#save_info'

  get 'application/status' => 'application#status'

  get 'objects' => 'objects#index'
  get 'objects/new' => 'objects#new'
  get 'objects/:id/edit' => 'objects#edit'
  post 'objects' => 'objects#update'
  delete 'objects/:id' => 'objects#destroy'

  get 'virtual_parameters' => 'virtual_parameters#index'
  get 'virtual_parameters/new' => 'virtual_parameters#new'
  get 'virtual_parameters/:id/edit' => 'virtual_parameters#edit'
  post 'virtual_parameters' => 'virtual_parameters#update'
  delete 'virtual_parameters/:id' => 'virtual_parameters#destroy'

  # get 'debug' => 'debug#index'
  # get 'debug/new' => 'debug#new'

  # get 'model_edit' => 'model_edit#index'
  # post 'model_edit/new' => 'model_edit#new'
  # post 'model_edit/delete' => 'model_edit#delete'
end
