# This file should contain all the record creation needed to seed the database with its default values.
# The data can then be loaded with the rake db:seed (or created alongside the db with db:setup).
#
# Examples:
#
#   cities = City.create([{ name: 'Chicago' }, { name: 'Copenhagen' }])
#   Mayor.create(name: 'Emanuel', city: cities.first)

# config/privileges/*.yml
ROLE_MAPPING = { 
    "Owner" => 1,
    "Admin" => 2,
    "System Operator" => 3,
    "Call Center Operator" => 4,
    "Technician Support" => 5
}

def create_privilege(resource, role_privileges)
    role_privileges.each do |k,v|
        role_id = ROLE_MAPPING[k]
        # Privilege.create(action: 'exist', weight: 1, resource: "/#{resource}", role_id: role_id) 
        v.each do |action|
            # Privilege.create(action: action, weight: 1, resource: "/#{resource}", role_id: role_id)
            DefaultPrivilege.create(action: action, weight: 1, resource: "/#{resource}", role_id: role_id)
        end
    end
end

privileges_file = Dir.glob("#{Rails.root}/config/privileges/*.yml")
privileges_file.each do |filename|
    privileges = YAML.load_file(filename)
    privileges.each do |k,v|
       create_privilege(k, v)
    end
end