# tp_config.rb
#

class TpConfig
  @@parameters=nil
  @@FILE_CURRENT_FEATURE_SET_VERSION = "/opt/agileacs/tmp/xj4j32l4ejvu045j6vup"
      
  class << self 
    
    def reload(field=nil)
      fields=[]
      if field.nil?
        fields << :current_feature_set_version
      else
        fields << field
      end

      fields.each do |key|
        case key
        when :current_feature_set_version
          reload_current_feature_set_version()
        end
      end
    end

    def reload_current_feature_set_version() 
      key = :current_feature_set_version 
      
      if !File.exist?(@@FILE_CURRENT_FEATURE_SET_VERSION)
        set_value(key, "lite", nil)
        return
      end
      
      if !has_field?(key) || !get_timestamp(key).eql?(File.mtime(@@FILE_CURRENT_FEATURE_SET_VERSION))
        File.open(@@FILE_CURRENT_FEATURE_SET_VERSION, "r") do |f|
          f.each_line.with_index do |line, index|
            if index == 0 
              set_value(key, line.squish, File.mtime(@@FILE_CURRENT_FEATURE_SET_VERSION))
            end
          end
        end
      end
    end


    def set_value(field, value, timestamp=nil)
      @@parameters = {} if @@parameters.nil? 
      @@parameters[field] = [value, timestamp]
    end

    def has_field?(field)
      @@parameters = {} if @@parameters.nil? 
      return @@parameters.key?(field)
    end

    def get_value(field)
      @@parameters = {} if @@parameters.nil? 
      return (@@parameters.key? field) ? @@parameters[field][0] : nil
    end

    def get_timestamp(field)
      @@parameters = {} if @@parameters.nil? 
      return (@@parameters.key? field) ? @@parameters[field][1] : nil
    end


    # return the value for the given key.
    # --------------------
    # key: value 
    # -----------------------
    # features-enable: true|false
    # -----------------------
    def get_config(key) 
      ret = nil
      case key
      when 'features-enable'
        ret = (get_vers().casecmp("lite") == 0) ? false : true
      when 'AUTO_GET_AFTER_SET_TIMEOUT_OR_FAULT'
        ret = false
      end
      return ret
    end
    
    # return the current feature set version, which defined in /opt/genieacs/genieacs_feature_set_version
    def get_vers()
      reload(:current_feature_set_version)
      return get_value(:current_feature_set_version)
    end
    
    # rename feature set version lite to normal
    def get_vers_rename(feature_set_version)
      ret = "normal"
      ret = (feature_set_version.casecmp("lite") == 0) ? "normal" : feature_set_version
      return ret
    end
  end
end