# lib/tplink/devices_task.rb
module DeviceTask
  include DevicesShowLib
  include Loggers

  def delete
    can?(:delete, '/devices/') do
      object = "[Device Detail][Setting]#{params[:id]}"
      http = create_api_conn()
      remove_device_from_license(params[:id], http)
      res = remove_device(params[:id], http)

      if res.code != '200'
        flash[:error] = "Unexpected error (#{res.code}): #{res.body}"
        agileACSLog(3, object, "Unexpected error (#{res.code}): #{res.body}")
      end
      agileACSLog(6, object, "Device #{params[:id]} deleted.")
      redirect_to controller: 'devices', action: 'index'
    end
  end

  def remove_device_from_license(id, http)
    license = {}
    license['action'] = 'remove'
    license['data'] = id
    res = http.post('/devices/acsapps/license', ActiveSupport::JSON.encode(license), 'Content-type' => 'application/json')
  end

  def remove_device(id, http)
    res = http.delete("/devices/#{URI.escape(id)}")
    res
  end

  def get_items(http, id, is_tr181 = false)
    id += '181' if is_tr181
    res = query_resource(http, 'csmenus', { '_id' => id })
    return [] if res[:result].size != 1

    res[:result][0]['items'] || []
  end
end
