# app type: 'Firmware Upgrade', 'Configure File Download', 'ESSID', 'PPPoE', 'Periodic Inform Interval', 'Firmware Upgrade with Schedule'
# model : 'C5', 'C20', '840N', '850N'
FWUP_CH = 1
CONFIG_CH = 2
ESSID_CH = 3
PPPOE_CH = 4
INFORM_CH = 5
FWUP_SCHEDULE_CH = 6
MAX_RETRY = 2

module Files
  def profile_application_name
    application_list = {}
    application_list[FWUP_CH] = 'Firmware Upgrade'
    application_list[CONFIG_CH] = 'Configure File Download'
    application_list[ESSID_CH] = 'ESSID'
    application_list[PPPOE_CH] = 'PPPoE'
    application_list[INFORM_CH] = 'Periodic Inform Interval'
    application_list[FWUP_SCHEDULE_CH] = 'Firmware Upgrade with Schedule'
    application_list
  end

  def is_used_by_profiles(filename)
    used = FALSE
    application_list = profile_application_name()
    res = query_resource(create_api_conn(), 'files/profiles', {})
    profiles = res[:result]
    profiles.each_with_index do |profile, _idx|
      app = profile['app']
      case app
        when application_list[FWUP_CH]
          if profile['fw_file'] == filename
            used = TRUE
            break
          end
        when application_list[CONFIG_CH]
          if profile['config'] == filename
            used = TRUE
            break
          end
        when application_list[PPPOE_CH]
          if profile['pppoe_file'] == filename
            used = TRUE
            break
          end
        when application_list[FWUP_SCHEDULE_CH]
          if profile['fw_file'] == filename
            used = TRUE
            break
          end
      end
    end
    used
  end
end
