# lib/tplink/log.rb
module Log
  LIMIT_ROW_NUM = 100000
 def get_log(id=nil)
    level_index = ['EMERGENCY', 'ALERT', 'CRITICAL', 'ERROR','WARN','NOTICE','INFO','DEBUG'] 
    @start_date = ""
    @end_date = ""

    if request.original_url.include?("devices")
      full_log = false
    else
      full_log = true
    end

    if params.include?(:level)
      @level = params[:level].to_i
    else
      @level = 5
    end

    if params.include?(:search)
      @search = params[:search]
    else
      @search = ""
    end

    if params.include?(:start_date)
        if params[:start_date].length > 0
            @start_date = params[:start_date]
            s_date = @start_date.to_time.strftime('%FT%TZ')
        end
    end

    if params.include?(:end_date)
      if params[:end_date].length > 0
          @end_date = (params[:end_date].to_time + 59.seconds).strftime('%F %T')
          e_date = @end_date.to_time.strftime('%FT%TZ')
      end
    end

    if full_log
      if params.include?(:facility)
          @facility = params[:facility].to_i
      else
          @facility = 2
      end

      if @facility === 0
          log_path_1 = "/var/log/genieacs/acs-operation.log"
          log_path_2 = "/var/log/genieacs/acs-operation.log.1"
      elsif @facility === 1
          log_path_1 = "/var/log/genieacs/acs-system.log"
          log_path_2 = "/var/log/genieacs/acs-system.log.1"
      else
          log_path_1 = "/var/log/genieacs/cwmp-access.log"
          log_path_2 = "/var/log/genieacs/cwmp-access.log.1"
      end
    else
      log_path_1 = "/var/log/genieacs/cwmp-access.log"
      log_path_2 = "/var/log/genieacs/cwmp-access.log.1"
    end

    if params.include?(:page)
      @page = params[:page].to_i
    else
      @page = 1
    end
    
    @logs = [] 
  
    if (File.exist?(log_path_1))  
      if id   
        text = IO.readlines(log_path_1).grep(/ [0-#{@level}] /).grep(/#{id}/i).grep(/#{@search}/i)
      else
        text = IO.readlines(log_path_1).grep(/ [0-#{@level}] /).grep(/#{@search}/i)  
      end

      if text.nil?
        @total = 0
        return
      end

      if (File.exist?(log_path_2)) 
        if params.include?(:id)
          text2 = IO.readlines(log_path_2).grep(/ [0-#{@level}] /).grep(/#{params[:id]}/i).grep(/#{params[:search]}/i)
        else
          text2 = IO.readlines(log_path_2).grep(/ [0-#{@level}] /).grep(/#{params[:search]}/i)
        end
        text = text2 + text
      end
 
      text.each_with_index do |f,index| 
        if text.length > LIMIT_ROW_NUM
          if text.length - LIMIT_ROW_NUM - 1 >= index
            next
          end
        end
        line = f.split(": ")
        h1 = {}
        
        if line[0] != nil         
          part = line[0].split(" ")
          h1["time"] = part.shift
          if s_date
            next if h1["time"].to_time < s_date                
          end
          if e_date
              next if h1["time"].to_time > e_date
          end
          h1["level"] = part.shift
          log_number = part.shift
          next if log_number.to_i > @level  
          part.shift
          if full_log
            if @facility === 2
              h1["deviceId"] = part * " "
            else
              h1["object"] = part * ""
            end
          else
            h1["deviceId"] = part * " "
          end
          line.shift
          h1["content"] = line * " "
          @logs.unshift(h1) 
        end
      end 
      @total = @logs.length   
      @logs = @logs[(@page-1)*100..@page*100-1]
        
    end
  end

  def export
    response.headers['Content-Type'] = 'text/csv'
    if params.include?(:id)
      facility = 2
    else
      facility = params[:facility].to_i
    end
    
    level = params[:level].to_i
    level_index = ['EMERGENCY', 'ALERT', 'CRITICAL', 'ERROR','WARN','NOTICE','INFO','DEBUG']

    s_date = params[:start_date].to_time.strftime('%FT%TZ') if params[:start_date].length > 0
    e_date = params[:end_date].to_time.strftime('%FT%TZ') if params[:end_date].length > 0

    if facility === 0
        log_path_1 = "/var/log/genieacs/acs-operation.log"
        log_path_2 = "/var/log/genieacs/acs-operation.log.1"
        filename ="log_acs_operation.csv"
    elsif facility === 1
        log_path_1 = "/var/log/genieacs/acs-system.log"
        log_path_2 = "/var/log/genieacs/acs-system.log.1"
        filename ="log_acs_system.csv"
    else
        log_path_1 = "/var/log/genieacs/cwmp-access.log"
        log_path_2 = "/var/log/genieacs/cwmp-access.log.1"
        filename = "log_cwmp_access.csv"
    end

    if (File.exist?(log_path_1))
      if params.include?(:id)
        text = IO.readlines(log_path_1).grep(/ [0-#{level}] /).grep(/#{params[:id]}/).grep(/#{params[:search]}/)
        fileHeader = ["Time","Level","Device Id","Log Content"]
      else
        text = IO.readlines(log_path_1).grep(/ [0-#{level}] /).grep(/#{params[:search]}/)
        if params[:facility] == 2
          fileHeader = ["Time","Level","Device Id","Log Content"]     
        else
          fileHeader = ["Time","Level","Object","Log Content"]    
        end
      end

      if (File.exist?(log_path_2)) 
        if params.include?(:id)
          text2 = IO.readlines(log_path_2).grep(/ [0-#{level}] /).grep(/#{params[:id]}/).grep(/#{params[:search]}/)
        else
          text2 = IO.readlines(log_path_2).grep(/ [0-#{level}] /).grep(/#{params[:search]}/)
        end
        text = text2 + text
      end

      io = File.new("/tmp/#{filename}","w")
      data = File.readlines("/tmp/#{filename}")

      if text.length > LIMIT_ROW_NUM
        rowNum = LIMIT_ROW_NUM
      else
        rowNum = text.length
      end

      text.each_with_index do |f,index| 
        if text.length > LIMIT_ROW_NUM
          if text.length - LIMIT_ROW_NUM - 1 >= index
            next
          end
        end

        log = []
        line = f.split(": ")

        #20200521 bill.chen - patch code for csv export; a log content includes the splitter ': ' will induce a corrupted message
        log_content = ""
        line.each_with_index do |str, index|
            if (index > 0)
                log_content += str
            end
        end
        line[1] = log_content
        #20200521 bill.chen

        if line[0] != nil   
          part = line[0].split(" ")
          log[0] = part.shift
          if s_date
            next if log[0].to_time < s_date                
          end
          if e_date
              next if log[0].to_time > e_date
          end
          log[1] = part.shift
          log_number = part.shift
          next if log_number.to_i > level 
          part.shift
          log[2] = part * " "
          part = line[1].split("\n")
          log[3] = part.shift
          log[3] = log[3].gsub('"','""')
          data[rowNum] = "\"#{log.join('","')}\""
          rowNum = rowNum - 1
        end
      end 
      data[0] = fileHeader.join(",")
      data = data.reject { |e| e.to_s.empty? }
      io.write(data.join("\n"))
      io.close

      send_file "/tmp/#{filename}"   
    end
  end
end
