module Models
	def is_model_used_by_profiles(modelname)
		used = FALSE
		http = create_api_conn()
		res = query_resource(create_api_conn(), 'profiles', nil)
		total = res[:total]
		if total > 0
					profiles = res[:result]
					for i in 0..(total-1)
				if profiles[i]['model'] == modelname
					used = TRUE
					break
				end
			end
		end
		return used
	end

	def is_model_used_by_files(modelname)
		used = FALSE
		http = create_api_conn()
		res = query_resource(create_api_conn(), 'files', nil)
		total = res[:total]
		if total > 0
					files = res[:result]
					for i in 0..(total-1)
				if files[i]['metadata']['model'] == modelname
					used = TRUE
					break
				end
			end
		end
		return used
	end

	def get_models()
		modelsAll = []

		http = create_api_conn()
		res = query_resource(create_api_conn(), 'model', nil)

		if res[:message] == "404 Not Found"
			modelsAll << "TL-WR840N"
			modelsAll << "TL-WR850N"
			modelsAll << "Archer C5"
			modelsAll << "Archer C20"
			modelsAll << "XN020-G3v"
			modelsAll << "Archer XR500v"
			modelsAll << "EN020-F5"
			modelsAll << "EC120-F5"
			modelsAll << "EC230-G1"
			modelsAll << "EC330-G5u"
			modelsAll << "HC220-G1"
			modelsAll << "HC221-G1R"
			modelsAll << "HC221-G1W"
			modelsAll << "Archer VR1200v"
			modelsAll << "Archer VR1210v"
			modelsAll << "VC420-G3v"
			return modelsAll
		end
		models = res[:result]
		models.each do |model|
			modelsAll << model['_id']
		end

		modelsAll = modelsAll.sort
		
		return modelsAll
	end

	def merge_models_from_devices_and_models()
		modelsAll = []
		aggregate_models = []
		aggregate_model_98 = []
		aggregate_model_181 = []

		http = create_api_conn()
				res = query_resource(create_api_conn(), 'model', nil)
					models = res[:result]
					models.each do |model|
						modelsAll << model['_id']
				end

				aggregate_model_98 << {"$group" => { "_id" => "$InternetGatewayDevice.DeviceInfo.ModelName._value"}}
				res_98 = aggregate(http, 'devices', aggregate_model_98)
				res_98[:result].each do |model|
					if model["_id"] != nil
						aggregate_models << model["_id"]
					end
				end
				aggregate_model_181 << {"$group" => { "_id" => "$Device.DeviceInfo.ModelName._value"}}
				res_181 = aggregate(http, 'devices', aggregate_model_181)
				res_181[:result].each do |model|
					if model["_id"] != nil
						aggregate_models << model["_id"]
					end
				end

			modelsAll = ((modelsAll + aggregate_models).uniq).sort

			return modelsAll
	end
end
