const http = require('http');
const HTTP_REQUEST_TIMEOUT = 5000; 
var send_post_device_request, send_post_diaglock_request, send_post_decrypt_request, send_post_connection_request;


send_post_device_request = function (deviceId, isNew, update, update2, callback)
{

        var data = {};
        data['deviceId'] = deviceId;
        data['isNew'] = isNew;
        if(update)
        data['update'] = update;
        if(update2)
        data['update2'] = update2;
        var json_data = JSON.stringify(data);
        var http_options = {
            hostname: '127.0.0.1',
            port: '17557',
            path: '/cwmp/devices',
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
                'Content-Length': Buffer.from(json_data).length,
                'Connection': 'close'
            }
        };
            //console.log("[http.request.js] http_post_data json_data = " + json_data);
            var req = http.request(http_options, (res) => {
                //console.log("res.statusCode:" + res.statusCode);
                if(res.statusCode !== 200)
                {
                    var err = {"name": res.statusCode, message: "unexpected res.statusCode "}
                    if(res.statusMessage) {
                        //console.log("unexpected res.statusMessage:" + res.statusMessage);
                        err.messasge = res.statusMessage
                    }
                    return callback(err);
                }

                //let data = '';
                res.on('data', function (chunk) {
                    //data += chunk;
                });

                res.on('end', function () {
                    return callback();
                });
                
                res.on('error', (error) => {
                    //console.error("res error:" + error);
                    return callback(error);
                });
                
                res.on('socket', function(socket) {
                    socket.setTimeout(HTTP_REQUEST_TIMEOUT);
                    return socket.on('timeout', function() {
                        if (!req.aborted) {
                            req.abort();
                        } 
                        return callback('timeout');
                    });
                });
            });
            
            // request.setTimeout(timeout[, callback])
            //   timeout: milliseconds before a request time out.
            //   callback: optional function to be called when a timeout occers. Same as binding to the 'timeout' event.
            // Once a socket is assigned to this request and is connected socket.setTimeout() will be called.
            req.setTimeout(HTTP_REQUEST_TIMEOUT, function() {
                if (!req.aborted) {
                    req.abort();
                    return callback('timeout');
                }
            });
            
            req.on('error', (error) => {
                console.error("req error:" + error);
                if (!req.aborted) {
                    req.abort();
                    return callback(error);
                }
            });
            
            req.write(json_data);
            req.end();
}

send_post_diaglock_request = function (deviceId, action, callback)
{
        var resultObj, body="";
        var data = {};
        data['action'] = action;

        var json_data = JSON.stringify(data);
        var http_options = {
            hostname: '127.0.0.1',
            port: '17557',
            path: '/diaglock/' + encodeURI(deviceId),
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
                'Content-Length': Buffer.from(json_data).length,
                'Connection': 'close'
            }
        };

            var req = http.request(http_options, (res) => {
                if(res.statusCode !== 200)
                {
                    return callback("unexpected res.statusCode");
                }
                res.on('error', (error) => {
                    resultObj = {
                        result: 'error', 
                        message: error
                    };
                    return callback(resultObj);
                })
                res.on('data', (d) => {
                    body += d;
                });
                res.on('end', function () {
                    return callback(body);
                });
                res.on('socket', function(socket) {
                    socket.setTimeout(HTTP_REQUEST_TIMEOUT);
                    return socket.on('timeout', function() {
                        res.abort();
                        resultObj = {
                            result: 'error', 
                            message: 'timeout'
                        };
                        return callback(resultObj);
                    });
                })
            });
            req.on('error', (error) => {
                resultObj = {
                    result: 'error', 
                    message: error
                };
                return callback(resultObj);
            })
            req.write(json_data);
            req.end();
}


var deleteDiagLock = function (deviceId, diagName) {
    var serialNumber = deviceId.split("-")[2] ;
    var promise_array_delete_upload_file = [];

    var promise_delete_diaglock = function() {
        return new Promise((resolve, reject) => {
        if (http_request && http_request.send_post_diaglock_request) {
            http_request.send_post_diaglock_request(deviceId, "unlockDiag", function (result) {
                    console.log(Date.now() + ' unlockDiag for ' + deviceId + ", " + diagName);
                resolve();
            });
        } else {
            resolve();
        }
        });
    }

    if (diagName == 'UploadDiagnostics') {
        promise_array_delete_upload_file.push(new Promise((resolve, reject) => {
            try {
                var filename = '/usr/share/nginx/html/upload/' + serialNumber + '.txt';
                require('fs').unlink(filename, function (err) {
                    console.log(Date.now() + ' Remove upload file [' + filename + '] on server.');
                    resolve();
                });
            } catch (ex) {
                resolve();
            }
        }));

        promise_array_delete_upload_file.push(new Promise((resolve, reject) => {
            try {
                var filename = '/var/ftp/upload/' + serialNumber + '.txt';
                require('fs').unlink(filename, function (err) {
                    console.log(Date.now() + ' Remove upload file [' + filename + '] on server.');
                    resolve();
                });
            } catch (ex) {
                resolve();
            }
        }));

        return Promise.all(promise_array_delete_upload_file).then(() => {
            return promise_delete_diaglock().then(() => {
                return;
            });
        });
    } else {
        return promise_delete_diaglock().then(() => {
            return;
        });
    }
}


send_post_decrypt_request = function (encrypt_data, callback)
{
        var resultObj, body="";
        var data = {};
        data['data'] = encrypt_data;

        var json_data = JSON.stringify(data);
        var http_options = {
            hostname: '127.0.0.1',
            port: '17557',
            path: '/decrypt/decrypt',
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
                'Content-Length': Buffer.from(json_data).length,
                'Connection': 'close'
            }
        };

        var req = http.request(http_options, (res) => {
            if(res.statusCode !== 200)
            {
                resultObj = {
                    result: 'error', 
                    message: 'unexpected res.statusCode ' + res.statusCode
                };
                return callback(resultObj);
            }
            res.on('error', (error) => {
                resultObj = {
                    result: 'error', 
                    message: error
                };
                return callback(resultObj);
            })
            res.on('data', (d) => {
                body += d;
            });
            res.on('end', function () {
                resultObj = {
                    result: 'success', 
                    message: body
                };
                return callback(resultObj);
            });
            res.on('socket', function(socket) {
                socket.setTimeout(HTTP_REQUEST_TIMEOUT);
                return socket.on('timeout', function() {
                    res.abort();
                    resultObj = {
                        result: 'error', 
                        message: 'timeout'
                    };
                    return callback(resultObj);
                });
            })
        });
        req.on('error', (error) => {
            resultObj = {
                result: 'error', 
                message: error
            };
            return callback(resultObj);
        })
        req.write(json_data);
        req.end();
}

send_post_connection_request = function (deviceId, callback)
{
        var resultObj, body="";

        var http_options = {
            hostname: '127.0.0.1',
            port: '17557',
            path: '/connection_request/' + encodeURI(deviceId),
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
                'Content-Length': 0,
                'Connection': 'close'
            }
        };

            var req = http.request(http_options, (res) => {
                if(res.statusCode !== 200)
                {
                    return callback("unexpected res.statusCode");
                }
                res.on('error', (error) => {
                    resultObj = {
                        result: 'error',
                        message: error
                    };
                    return callback(resultObj);
                })
                res.on('data', (d) => {
                    body += d;
                });
                res.on('end', function () {
                    resultObj = {
                        result: 'success',
                        message: body
                    };
                    return callback(resultObj);
                });
                res.on('socket', function(socket) {
                    socket.setTimeout(HTTP_REQUEST_TIMEOUT);
                    return socket.on('timeout', function() {
                        res.abort();
                        resultObj = {
                            result: 'error',
                            message: 'timeout'
                        };
                        return callback(resultObj);
                    });
                })
            });
            req.on('error', (error) => {
                resultObj = {
                    result: 'error',
                    message: error
                };
                return callback(resultObj);
            })
            req.end();
}

exports.send_post_device_request = send_post_device_request;
exports.send_post_diaglock_request = send_post_diaglock_request;
exports.send_post_decrypt_request = send_post_decrypt_request;
exports.send_post_connection_request = send_post_connection_request;
exports.deleteDiagLock = deleteDiagLock;
