var options, getConfig, getRootNode, findRootNode,common;

common = require('../common');

options = {
  ACS_KEYMETHOD: {
    type: 'string',
    "default": 'GetParameterValuesResponse'
  },
  ACS_KEYNAMEMAC: {
    type: 'string',
    "InternetGatewayDevice": 'InternetGatewayDevice.LANDevice.1.LANEthernetInterfaceConfig.1.MACAddress',
    "Device": 'Device.Ethernet.Link.1.MACAddress'
  },
  ACS_KEYNAMEMODEL: {
    type: 'string',
    "InternetGatewayDevice": 'InternetGatewayDevice.DeviceInfo.ModelName',
    "Device": 'Device.DeviceInfo.ModelName'
  },
  ACS_KEYNAMESWVER:{
    type: 'string',
    "InternetGatewayDevice": 'InternetGatewayDevice.DeviceInfo.SoftwareVersion',
    "Device": 'Device.DeviceInfo.SoftwareVersion'
  },
  ACS_KEYNAMESIG:{
    type: 'string',
    "InternetGatewayDevice": 'InternetGatewayDevice.DeviceInfo.X_TP_AgileACS_Sig',
    "Device": 'Device.DeviceInfo.X_TP_AgileACS_Sig'
  },
  ACS_ACSACTION: {
    type: 'string',
    "default": 'licensecheck'
  }
};

getValueFromSession = function (acs_keyname,sessionContext,root){
  var val, KEYNAME, path, attributes;
  val = null;
  KEYNAME = common.parsePath(getConfig(acs_keyname, root));
  path = sessionContext.deviceData.paths.get(KEYNAME);
  attributes = sessionContext.deviceData.attributes.get(path);
  if (attributes) 
    if (attributes.value){
      val = attributes.value[1][0];}
      
  return val;
}

getConfig = function (option_name, root_node) {
  var ret;
  try {
    ret = options[option_name]['default'];
    if (!ret) {
      ret = options[option_name][root_node];
    } 
  } catch (ex) {
    //console.log("license-check.js: getConfig("+option_name+","+root_node+"), Exception=\n"+ex);
  } finally {
    //console.log("license-check.js: getConfig("+option_name+","+root_node+"), ret = "+ret);
  }
  return ret;
};

getRootNode = function (parameter_name) {
  var ret  = "NULL";
  try {
    var index = parameter_name.indexOf("Device.");
    switch(index) {
    case 0:
      ret  = "Device";
      break;
    case 15:
      ret  = "InternetGatewayDevice";
      break;
    case -1:
      default:
      ret  = "NULL";
    }
  } catch (ex) {
    //console.log("license-check.js: getRootNode(), Exception=\n"+ex);
    ret  = "NULL";
  } finally {
    //console.log("license-check.js: getRootNode(), ret="+ret);
  }
  return ret;
};

findRootNode = function (parameterList) {
  var ret  = "NULL";
  try {
    // Ref: soap.js# function parameterValueList(xml)
    if (parameterList && parameterList.length > 0 ) {
      ret = getRootNode(parameterList[0][0]);
    }
  } catch (ex) {
    //console.log("license-check.js: findRootNode(), Exception=\n"+ex);
    ret  = "NULL";
  } finally {
    //console.log("license-check.js: findRootNode(), ret="+ret);
  }
  return ret;
};

exports.getConfig = getConfig;

exports.getRootNode = getRootNode;

exports.findRootNode = findRootNode;

exports.getValueFromSession = getValueFromSession;