'use strict'

const koarouter = require('koa-router')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]
let AggregateQuery = require('./class/aggregate_query')

subroute.use(require('koa-bodyparser')())

subroute.head(`/${subroutepath}`, async (ctx) => {
    try {
        let aggregate_pipeline = []
        if (ctx.request.query)
            aggregate_pipeline = ctx.request.query.aggregate_pipeline
        let res = await dbAggregateTmpDevice(JSON.parse(aggregate_pipeline))
        ctx.set('total', res.length)
        ctx.status = 200
    } catch (err) {
        ctx.throw(400)
    }
})

subroute.get(`/${subroutepath}`, async (ctx) => {
    try {
        let aggregate_pipeline = []
        if (ctx.request.query)
            aggregate_pipeline = ctx.request.query.aggregate_pipeline
        let res = await dbAggregateTmpDevice(JSON.parse(aggregate_pipeline))
        ctx.set('total', res.length)
        ctx.body = res
    } catch (err) {
        ctx.throw(400)
    }
})

subroute.post(`/${subroutepath}`, async (ctx) => {
    try {
        let aggregate_pipeline = []
        if (ctx.request.body)
            aggregate_pipeline = ctx.request.body.aggregate_pipeline
        let res = await dbAggregateTmpDevice(JSON.parse(aggregate_pipeline))
        ctx.set('total', res.length)
        ctx.body = res
    } catch (err) {
        ctx.throw(400)
    }
})


let dbAggregateTmpDevice = async (aggregate_pipeline) => {
    let aggregateQuery = new AggregateQuery()
    return aggregateQuery.tmpDevice_aggregate_query(aggregate_pipeline)
        .then(res => {
            return res
        })
        .catch(err => {
            return err
        })
}

subroute.destruct = () => {
    AggregateQuery.destruct()
}

module.exports = subroute
