'use strict'

const koarouter = require('koa-router')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]
let { agileConfig, stringTable, MongoClass } = require('tplib')
let tpdb = new MongoClass(agileConfig.get(stringTable.url.dbTplink))

subroute.get(`/${subroutepath}`, async (ctx) => {
    try {
        let aggregate_pipeline = []
        if (ctx.request.query)
            aggregate_pipeline = ctx.request.query.aggregate_pipeline
        let res = await dbAggregateInvalidDevice(JSON.parse(aggregate_pipeline))
        ctx.body = res
    } catch (err) {
        ctx.throw(400)
    }
})

let dbAggregateInvalidDevice = async (aggregate_pipeline) => {
    return new Promise((resolve, reject) => {
        tpdb.aggregate(stringTable.collection.invalidDeviceReport, aggregate_pipeline, function (err, res) {
            if (err) {
                reject(err)
            }
            resolve(res)
        })
    })
}

subroute.destruct = () => {
  tpdb.disconnectDb()
}

module.exports = subroute
