'use strict'

const koarouter = require('koa-router')

const { connectionRequestPromise, destructCR } = require('./connection_request')

const prefix = '/' + __dirname.split('/').pop()  // use folder name as route path
const route = new koarouter({ prefix })

let subrouteList = {}

// include general purpose body parser here
route.use(require('koa-bodyparser')())

// default route for this prefix
route.post('/:id', async ctx => {
  try {
    await connectionRequestPromise(ctx.params['id'])
    ctx.status = 200
  } catch(err) {
    ctx.throw(400)
  }
})

// import other subroutes and return result
let getRoute = async (destruct) => {
  // destruct function
  if(destruct) {
    destructCR()
    for(let i in subrouteList) {
      subrouteList[i].destruct()
    }
    return
  }
  return route
}

module.exports = getRoute
