'use strict'

const koarouter = require('koa-router')

const prefix = '/' + __dirname.split('/').pop()  // use folder name as route path
const route = new koarouter({ prefix })

const { agileConfig, stringTable, MongoClass } = require('tplib')

const tpdb = new MongoClass(agileConfig.get(stringTable.url.dbTplink))

let subrouteList = {}

// handler for query resource /notification
route.get('/', async ctx => {
  let dbQuery = ctx.query['query'] ? ctx.query['query'] : null
  try {
    let result = await tpdb.queryResource(stringTable.collection.cpeSetting , dbQuery)
    ctx.set('total', result['total'])
    ctx.body = result['result']
  } catch(err) {
    ctx.throw(400)
  }
})

// import other subroutes and return result
let getRoute = async (destruct) => {
  // destruct function
  if(destruct) {
    tpdb.disconnectDb()
    for(let i in subrouteList) {
      subrouteList[i].destruct()
    }
    return
  }
  return route
}

module.exports = getRoute
