'use strict'

const koarouter = require('koa-router')

const prefix = '/' + __dirname.split('/').pop()  // use folder name as route path
const route = new koarouter({ prefix })

let subrouteList = {}

// include general purpose body parser here
route.use(require('koa-bodyparser')())

// import other subroutes and return result
let getRoute = async (destruct) => {
  // destruct function
  if(destruct) {
    for(let i in subrouteList) {
      subrouteList[i].destruct()
    }
    return
  }

  let subEntryFiles = null

  // find subroute files
  try {
    subEntryFiles = await new Promise((resolve, reject) => {
      require("glob")(`${__dirname}/*.sub.js`, (err, files) => {
        if(err) reject(err)
        resolve(files)
      })
    })
  } catch(err) {
    // return route without subroute
    return route
  }

  // add subroute to route
  subEntryFiles.forEach( item => {
    let filename = item.split('/').pop()
    let subroute = require(`./${filename}`)
    subrouteList[filename] = subroute
    route.use(subroute.routes(), subroute.allowedMethods())
  })

  return route
}

module.exports = getRoute
