'use strict'

const koarouter = require('koa-router')

const AgileCryptor = require('tplib/agile-cryptor')
const ageilConfig = require('tplib/agile-config')

const prefix = '/' + __dirname.split('/').pop()  // use folder name as route path
const route = new koarouter({ prefix })
const agileCryptor = new AgileCryptor(ageilConfig.get('ENCRYPT_ENABLE'), ageilConfig.getRedisConfig())

let subrouteList = {}

// include general purpose body parser here
route.use(require('koa-bodyparser')())

// /decrypt/decrypt
route.post('/decrypt', async ctx => {
  if(!ctx.request.body.data) return ctx.throw(400)
  try {
    let decrypted = await agileCryptor.decrypt(ctx.request.body.data)
    return Object.assign(ctx, { status:200, body: decrypted })
  } catch(err) {
    return ctx.throw(400)
  }
})

let getRoute = async (destruct) => {
  // destruct function
  if(destruct) {
    agileCryptor.disconnectRedis()
    for(let i in subrouteList) {
      subrouteList[i].destruct()
    }
    return
  }
  return route
}

module.exports = getRoute
