let query_util = require('tplib/query')
let devices_util = require('../devices_util')

const MongoClass = require('tplib/mongo-class')
const agileConfig = require('tplib/agile-config')

const ENCRYPT_ENABLE = agileConfig.get('ENCRYPT_ENABLE')

class DevicesMongoClass extends MongoClass {
  queryProcResource(collection, query, projection, sort, skip, limit, method='GET') {
    return new Promise((resolve) => {
      let need_lastinform_update;

      if (!this.isConnected()) return this.handleError()

      let queryHash, projectionHash, cur, response;
      if (query != null) {
        try {
          queryHash = query_util.expand(query);
        } catch (err) {
          return this.handleError()
        }
      } else {
        queryHash = {}
      }

      if (projection != null) {
        projectionHash = {};
        let ref1 = projection.split(',');
        for (let j = 0, len = ref1.length; j < len; j++) {
          let p = ref1[j];
          p = p.trim();
          projectionHash[p] = 1;
        }
      }

      cur = this.db.collection(collection).find(queryHash, projectionHash, { batchSize: 50 })
      if (sort != null) {
        let s = JSON.parse(sort);
        sort = {};
        for (let k in s) {
          sort[k] = s[k];
        }
        cur.sort(sort);
      }

      if (skip != null) {
        cur.skip(parseInt(skip));
      }
      if (limit != null) {
        cur.limit(limit = parseInt(limit));
      }
      return cur.count(false, async function (err, total) {
        response = {}
        response['total'] = total
        if(method === 'HEAD') {
          resolve(response)
        }

        response['result'] = "[\n"
        let i = 0;
        need_lastinform_update = total;
        return cur.each(async function (err, item) {
          if (err) {
            response['result'] = response['result'].concat("\n]");
            resolve(response)
          }
          if (item != null) {
            if(ENCRYPT_ENABLE) await devices_util.decrypt_all(item);
            devices_util.get_tmpdb_lastInform(item)
            .then((item) => {
              if (i++) {
                response['result'] = response['result'].concat(",\n");
              }
              response['result'] = response['result'].concat(JSON.stringify(item));
              if(need_lastinform_update)
                need_lastinform_update--;
              if(need_lastinform_update == 0 || ((limit != null) && i >= limit)){
                response['result'] = response['result'].concat("\n]");
                resolve(response)
              }
            })
            .catch((err) => {
              response['result'] = response['result'].concat("\n]");
              resolve(response)
            })
          }
          if (((item == null) && (need_lastinform_update == 0)) || ((limit != null) && i >= limit)) {
             response['result'] = response['result'].concat("\n]");
             resolve(response)
          }
        })
      })
    })
  }
}

module.exports = DevicesMongoClass