'use strict'

const koarouter = require('koa-router')

const MongoClass = require('tplib/mongo-class')
const agileConfig = require('tplib/agile-config')
const stringTable = require('tplib/string-table.json')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]

const dbTplink = new MongoClass(agileConfig.get(stringTable.url.dbTplink))

subroute.get(`/${subroutepath}`, async ctx => {
  try {
    let dbQuery = ctx.query['query'] ? ctx.query['query'] : null
    let result = await dbTplink.queryResource(stringTable.collection.cpeSetting, dbQuery)
    ctx.set('total', result['total'])
    ctx.body = result['result']
  } catch(err) {
    console.log(err)
    ctx.throw(400)
  }
})

subroute.destruct = () => {
  dbTplink.disconnectDb()
}

module.exports = subroute
