'use strict'

const koarouter = require('koa-router')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]

const MongoClass = require('tplib/mongo-class')

const agileConfig = require('tplib/agile-config')
const stringTable = require('tplib/string-table.json')

const dbTplink = new MongoClass(agileConfig.get(stringTable.url.dbTplink))

// get xmpp settings
subroute.get(`/${subroutepath}`, async ctx => {
  let response = { 'xmpp': 'disable', 'xmpp_keepalive_interval': 300 }
  let sysSetting = await dbTplink.findOne(stringTable.collection.sysSetting, { _id: 'service' }, { xmpp: 1 })
  if(sysSetting && sysSetting.xmpp) response.xmpp = sysSetting.xmpp
  console.log(sysSetting)
  ctx.body = response
})

subroute.destruct = () => {
  dbTplink.disconnectDb()
}

module.exports = subroute
