'use strict'

let { AgileACSApps } = require('tplib')
const koarouter = require('koa-router')
const bodyParser = require('koa-bodyparser')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]
const acsapps_path = "/opt/agileacs/bin/acsutils_files"

// use general body parser here
subroute.use(bodyParser())

subroute.post(`/${subroutepath}`, async ctx => {
  var files, cmd;
  if(ctx.request.body && Object.keys(ctx.request.body).length != 0)
  {
    files = ctx.request.body
    cmd = acsapps_path + ' ' + files['action'] + ' ' + files['data']
    let res = await acsappsFiles(cmd)
    ctx.status = res['code'] 
    ctx.body = res['message'] 
    return 
  }
  else
  {
    return ctx.throw(404, 'No HTTP Body')
  }
})

subroute.all(`/${subroutepath}`, ctx => {
  // request related
  ctx.set('Allow', 'POST')
  ctx.throw(405)
  return 
})

let acsappExe = function (cmd)
{
  return new Promise((resolve, reject) => {
    AgileACSApps.exec(cmd, (err, stdout, stderr) => {
      var result = {
        'code': 404,
        'message':'Unknow error'
      }
      if (err) {
        result['code'] = 202
        result['message'] = err
      }
      if (stderr) {
        result['code'] = 202
        result['message'] = stderr
      }
      if(stdout.length)
      {
        result['code'] = 200
        result['message'] = stdout
      }
      resolve(result)
    })
  })
}

let acsappsFiles = async (cmd) => {
  return acsappExe(cmd)
    .then(res => {
      return res
    })
}

subroute.destruct = () => {}

module.exports = subroute
