'use strict'

// let { AgileACSApps } = require('tplib')
const koarouter = require('koa-router')
const bodyParser = require('koa-bodyparser')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]
let { agileConfig, stringTable, MongoClass } = require('tplib')
let geniedb = new MongoClass(agileConfig.get(stringTable.url.dbGenie))

// use general body parser here
subroute.use(bodyParser())

subroute.get(`/${subroutepath}`, async ctx => {
  try {
    let query = null
    if (ctx.request.query) {
      query = ctx.request.query['query']
    }
    let res = await dbFindProfiles(query)
    ctx.set('total', res['total'])
    ctx.body = res['result']
  } catch (err) {
    ctx.throw(400)
  }
})

subroute.all(`/${subroutepath}`, ctx => {
  // request related
  ctx.set('Allow', 'GET')
  ctx.throw(405)
  return 
})

let dbFindProfiles = async (query) => {
  return geniedb.queryResource(stringTable.collection.profiles, query)
    .then(res => {
      return res
    })
    .catch(err => {
      return err
    })
}

subroute.destruct = () => {
  geniedb.disconnectDb()
}

module.exports = subroute
