'use strict'

let { AgileACSApps, stringTable } = require('tplib')
const koarouter = require('koa-router')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]
const acsapps_path = "/opt/agileacs/bin/acsutils_license"

subroute.post(`/${subroutepath}`, async ctx => {
  var license, cmd;
  if(ctx.request.body)
  {
    license = ctx.request.body
    cmd = acsapps_path + ' ' + license['action'] + ' ' + license['data']
    console.log(subroutepath + " post " + cmd)
    let res = await acsappsLicenses(cmd)
    ctx.status = res['code'] 
    ctx.body = res['message'] 
    return 
  }
  else
  {
    return ctx.throw(404, 'No HTTP Body')
  }
})


subroute.put(`/${subroutepath}`, async ctx => {
  let res = await acsappsLicenses(acsapps_path)
  ctx.status = res['code'] 
  ctx.body = res['message'] 
  return
})


subroute.all(`/${subroutepath}`, ctx => {
  // request related
  ctx.set('Allow', 'PUT, POST')
  ctx.throw(405)
  return 
})

let acsappExe = function (cmd)
{
  return new Promise((resolve, reject) => {
    AgileACSApps.exec(cmd, (err, stdout, stderr) => {
      var result = {
        'code': 404,
        'message':'Unknow error'
      }
      if (err) {
        result['code'] = 202
        result['message'] = err
      }
      if (stderr) {
        result['code'] = 202
        result['message'] = stderr
      }
      if(stdout.length)
      {
        result['code'] = 200
        result['message'] = stdout
      }
      resolve(result)
    })
  })
}

let acsappsLicenses = async (cmd) => {
  return acsappExe(cmd)
    .then(res => {
      return res
    })
}

subroute.destruct = () => {}

module.exports = subroute
