'use strict'

const koarouter = require('koa-router')

const ProxyHandler = require('tplib/proxy_handler')

const prefix = '/' + __dirname.split('/').pop()  // use folder name as route path
const route = new koarouter({ prefix })
const proxyHandler = new ProxyHandler()

let subrouteList = {}

// default route for this prefix
route.get('/:ip', proxyHandler.handler)

// import other subroutes and return result
let getRoute = async (destruct) => {
  // destruct function
  if(destruct) {
    for(let i in subrouteList) {
      subrouteList[i].destruct()
    }
    return
  }

  return route
}

module.exports = getRoute
