'use strict'

const koarouter = require('koa-router')
const { ProxyHandler } = require('tplib')
const prefix = '/' + __dirname.split('/').pop()  // use folder name as route path
const route = new koarouter({ prefix })

const proxyHandler = new ProxyHandler()

let subrouteList = {}

route.use(require('koa-bodyparser')())

route.put('/:id', proxyHandler.handler)
route.delete('/:id', proxyHandler.handler)
route.all('/', proxyHandler.handler)

let getRoute = async (destruct) => {
  // destruct function
  if(destruct) {
    for(let i in subrouteList) {
      subrouteList[i].destruct()
    }
    return
  }

  let subEntryFiles = null

  try {
    subEntryFiles = await new Promise((resolve, reject) => {
      require("glob")(`${__dirname}/*.sub.js`, (err, files) => {
        if (err) reject(err)
        resolve(files)
      })
    })
  } catch (err) {
    return route
  }

  subEntryFiles.forEach(item => {
    let filename = item.split('/').pop()
    let subroute = require(`./${filename}`)
    subrouteList[filename] = subroute
    route.use(subroute.routes(), subroute.allowedMethods())
  })

  return route
}

module.exports = getRoute
