let query = require('tplib/query');
let { agileConfig, stringTable, MongoClass, agileLogger } = require('tplib')
let geniedb = new MongoClass(agileConfig.get(stringTable.url.dbGenie))
let tmpdb = new MongoClass(agileConfig.get(stringTable.url.dbTmp))
class ProfileProgress {
    static destruct() {
        agileLogger.disconnectDb()
        geniedb.disconnectDb()
        tmpdb.disconnectDb()
    }

    expand(match_query) {
        var ret = match_query
        try {
            ret = query.expand(match_query)
        } catch (ex) {
            console.log(ex)
        }
        return ret
    }


    proc_fault_query(fault_query) {
        return new Promise((resolve) => {
            //console.log("[proc_fault_query] fault_query = "+ JSON.stringify(fault_query))
            return geniedb.find(stringTable.collection.faults, fault_query, { 'device': true }, function (_error, _results) {
                if (_error) {
                    console.log("[proc_fault_query] _error " + _error)
                    resolve()
                }
                //console.log("[proc_fault_query] _results = "+ JSON.stringify(_results))
                resolve(_results)
            })
        })
    }

    proc_aggregate_query(aggregate_pipeline) {
        return new Promise((resolve) => {
            aggregate_pipeline.forEach((element) => {
                if (element['$match']) {
                    element['$match'] = this.expand(element['$match'])
                }
            })
            //console.log("aggregate_pipeline="+JSON.stringify(aggregate_pipeline))
            tmpdb.aggregate(stringTable.collection.tmpdevices, aggregate_pipeline, function (_error, _results) {
                if (_error) {
                    let err = _error
                    console.log("[proc_aggregate_query] " + err.name + ": " + err.message)
                    resolve()
                }
                //console.log("[proc_aggregate_query] _results = " + JSON.stringify(_results))
                resolve(_results)
            })
        })
    }

    get_devtotal(query) {
        return this.proc_aggregate_query(query)
    }

    get_failedtotal(query) {
        //console.log("[get_failedtotal] query = "+JSON.stringify(query))
        return this.proc_fault_query(query)
    }

    get_donetotal(query) {
        return this.proc_aggregate_query(query)
    }

    get_todototal(todo_query, failed_query) {
        var failed_result = []
        var todo_result = []
        var _results = []
        var failed_exist
        return Promise.all([
            this.proc_aggregate_query(todo_query),
            this.get_failedtotal(failed_query)
        ])
            .then((results) => {
                todo_result = results[0]
                failed_result = results[1]
                if (failed_result && failed_result.length) {
                    for (let i = 0; i < todo_result.length; i++) {
                        failed_exist = 0
                        for (let j = 0; j < failed_result.length; j++) {
                            if (todo_result[i]['_id'] === failed_result[j]['device']) {
                                failed_exist = 1
                                break
                            }
                        }
                        if (failed_exist === 0)
                            _results.push(todo_result[i])
                    }
                }
                else {
                    _results = todo_result
                }
                //console.log("[get_todototal] _results = "+ JSON.stringify(_results))
                return _results
            })
    }

    get_profileprogress_all(progress_querys) {
        return Promise.all(progress_querys.map(progress_query => {
            var progress = {}
            progress['id'] = progress_query['id']
            progress['failed'] = 0
            progress['done'] = 0
            progress['todo'] = 0
            progress['total'] = 0
            return Promise.all([
                this.get_failedtotal(progress_query['failed']).then((result) => {
                    if (result) progress['failed'] = result.length
                    return
                }),
                this.get_donetotal(progress_query['done']).then((result) => {
                    if (result) progress['done'] = result.length
                    return
                }),
                this.get_devtotal(progress_query['total']).then((result) => {
                    if (result) progress['total'] = result.length
                    return
                }),
                this.get_todototal(progress_query['todo'], progress_query['failed']).then((result) => {
                    if (result) progress['todo'] = result.length
                    return
                })
            ]).then(() => {
                //console.log("[get_profileprogress_all] progress = " + JSON.stringify(progress))
                return progress
            })
        }))
    }

    get_profileprogress_head(progress_querys) {
        return this.proc_aggregate_query(progress_querys);
    }
}

module.exports = ProfileProgress
