'use strict'

const koarouter = require('koa-router')

const MongoClass = require('tplib/mongo-class')
const agileConfig = require('tplib/agile-config')
const stringTable = require('tplib/string-table.json')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]

const dbGenie = new MongoClass(agileConfig.get(stringTable.url.dbGenie))
const dbTmp = new MongoClass(agileConfig.get(stringTable.url.dbTmp))

subroute.use(require('koa-bodyparser')())


subroute.delete(`/all/${subroutepath}/:channel`, async ctx => {
  await handleChannel(ctx)
})

/**
 * Update Channel Handler
 * @param {object} ctx http context
 */
async function handleChannel(ctx) {
  const query = {'channel' : ctx.params['channel']}

  try {
    await dbGenie.deleteMany(stringTable.collection.faults, query)
    ctx.status = 200
  } catch (err) {
    ctx.throw(400)
  }
}

subroute.destruct = () => {
  dbGenie.disconnectDb()
  dbTmp.disconnectDb()
}

module.exports = subroute
