const MongoClass = require('tplib/mongo-class')
const AgileCacheClass = require('tplib/agile-cache')
const agileConfig = require('tplib/agile-config')
const agileCache = new AgileCacheClass(agileConfig.getRedisConfig())

class ProvisionsMongoClass extends MongoClass {
    queryResourceProvisions(collection, query, projection, sort, skip, limit) {
        return new Promise((resolve) => {
            if (!this.isConnected()) return this.handleError()
            let queryHash, projectionHash, cur, response
            if (query != null) {
                try {
                    queryHash = JSON.parse(query)
                } catch (err) {
                    return this.handleError()
                }
            } else {
                queryHash = {}
            }

            if (projection != null) {
                projectionHash = {}
                let ref1 = projection.split(',')
                for (let j = 0, len = ref1.length; j < len; j++) {
                    let p = ref1[j]
                    p = p.trim()
                    projectionHash[p] = 1
                }
            }

            cur = this.db.collection(collection).find(queryHash, projectionHash, { batchSize: 50 })
            if (sort != null) {
                let s = JSON.parse(sort)
                sort = {};
                for (let k in s) {
                    sort[k] = s[k]
                }
                cur.sort(sort);
            }

            if (skip != null) {
                cur.skip(parseInt(skip))
            }
            if (limit != null) {
                cur.limit(limit = parseInt(limit))
            }
            return cur.count(false, async function (err, total) {
                response = {}
                response['total'] = total
                response['result'] = "[\n"
                let i = 0;
                cur.toArray()
                    .then(array => {
                        Promise.all(array.map(item => {
                            return new Promise(async function (resolve) {
                                if (item != null) {
                                    if (item.encrypt === 1) {
                                        agileCache.getPromise(item._id)
                                            .then(p => {
                                                if (p) item.script = p
                                                if (i++) response['result'] = response['result'].concat(",\n")
                                                response['result'] = response['result'].concat(JSON.stringify(item))
                                                resolve()
                                            })
                                            .catch(err => {
                                                rej(err)
                                            })
                                    } else {
                                        if (i++) response['result'] = response['result'].concat(",\n")
                                        response['result'] = response['result'].concat(JSON.stringify(item))
                                        resolve()
                                    }
                                }
                                if ((item == null) || ((limit != null) && i >= limit)) {
                                    resolve()
                                }
                            });
                        })).then(() => {
                            response['result'] = response['result'].concat("\n]")
                            resolve(response)
                        }).catch(e => {
                            response['result'] = response['result'].concat("\n]")
                            return this.handleError()
                        });
                    }).catch(e => {
                        response['result'] = response['result'].concat("\n]")
                        return this.handleError()
                    });
            })
        })
    }
}

module.exports = ProvisionsMongoClass