'use strict'

const koarouter = require('koa-router')

const AgileACSApps = require('tplib/agile-acsapps')

const prefix = '/' + __dirname.split('/').pop()  // use folder name as route path
const route = new koarouter({ prefix })

let subrouteList = {}

// include general purpose body parser here
route.use(require('koa-bodyparser')())

/**
 * handles restore/reset
 * expect ctx.request.body = {action: ['reset']} or {action: [mount_point, filename]}
 */
route.post('/', ctx => {
  // response cmd when test
  if(process.env.NODE_ENV === 'test') {
    ctx.body = {
      restore: AgileACSApps.genCmdStringWithSafeArgs('/usr/bin/nice', [
        '-n19',
        '/opt/agileacs/bin/agileacs-restore.sh',
        ...ctx.request.body.action
      ])
    }
    if(ctx.request.body.action[0] !== 'reset') {
      ctx.body.progress = AgileACSApps.genCmdStringWithSafeArgs('/opt/agileacs/bin/agileacs-restore-progress.sh',
      ctx.request.body.action[0])
    }

    return ctx.status = 200
  }

  try {
    // seems this api do not need to wait command response, no async/await here
    AgileACSApps.execCmdWithSafeArgs('/usr/bin/nice', [
      '-n19',
      '/opt/agileacs/bin/agileacs-restore.sh',
      ...ctx.request.body.action
    ])
    if(ctx.request.body.action[0] !== 'reset') {
      AgileACSApps.execCmdWithSafeArgs('/opt/agileacs/bin/agileacs-restore-progress.sh',
      ctx.request.body.action[0])
    }
    ctx.status = 200
  } catch(err) {
    console.log(err)
    response202(ctx)
  }
})

function response202(ctx) {
  ctx.set('Cache-Control', 'no-cache')
  ctx.status = 202
}

// import other subroutes and return result
let getRoute = async (destruct) => {
  // destruct function
  if(destruct) {
    for(let i in subrouteList) {
      subrouteList[i].destruct()
    }
    return
  }
  return route
}

module.exports = getRoute
