'use strict'

const koarouter = require('koa-router')

const prefix = '/' + __dirname.split('/').pop()  // use folder name as route path
const route = new koarouter({ prefix })

const AgileACSApps = require('tplib/agile-acsapps')
const MongoClass = require('tplib/mongo-class')
const agileConfig = require('tplib/agile-config')
const stringTable = require('tplib/string-table.json')

let dbTplink = new MongoClass(agileConfig.get(stringTable.url.dbTplink))

let subrouteList = {}

// include general purpose body parser here
route.use(require('koa-bodyparser')())

// user operation record
route.post(['/login_counts', '/change_password_counts'], async ctx => {
  if(!ctx.request.rawBody || Object.keys(ctx.request.body) === 0) {
    ctx.set('Cache-Control', 'no-cache')
    ctx.status = 204
    return
  }
  let task = ctx.request.body
  let operationStatus = task.levelnum === 6 ? 1 : 0
  try {
    let { stdout } = await AgileACSApps.execCmdWithSafeArgs('cat', '/opt/agileacs/tmp/xj4j32l4ejvu045j6vup')
    if(stdout.trim().toLowerCase() !== 'lite') {
      let op = ctx.path.split('/').find(s => s.includes('_counts')).replace('_counts', '')
      await dbTplink.insert(stringTable.collection.tmpUserOperation, {
        "operation": op,
        "user": task.user,
        "status": operationStatus,
        "timestamp": new Date().valueOf()
      })
    }
    ctx.status = 200
  } catch (e) {
    ctx.throw(400)
  }
})

// import other subroutes and return result
let getRoute = async (destruct) => {
  // destruct function
  if(destruct) {
    dbTplink.disconnectDb()
    for(let i in subrouteList) {
      subrouteList[i].destruct()
    }
    return
  }
  return route
}

module.exports = getRoute
