'use strict'

const koarouter = require('koa-router')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]

const { agileConfig, stringTable, MongoClass, AgileACSApps, AgileCryptor } = require('tplib')
const tpdb = new MongoClass(agileConfig.get(stringTable.url.dbTplink))

// debug flag
const DBG_CPE = false

function dbg_console_req(ctx) {
    if (DBG_CPE) {
        console.log(`Now we are at ${ctx.req.url}`)
        console.log(ctx.method + " " + ctx.path)
        if (ctx.request.body) {
            console.log(ctx.request.body)
            console.log(typeof ctx.request.body)
            //console.log(Object.keys(ctx.request.body).length)
        }
    }
}

function dbg_console_res(ctx, cmd) {
    if (DBG_CPE) {
        if (cmd) console.log('cmd= ' + cmd)
        console.log(ctx.response)
    }
}

subroute.use(require('koa-bodyparser')())

// '/system/license'
subroute.get(`/${subroutepath}`, async ctx => {
    dbg_console_req(ctx)
    try {
        let result = await tpdb.queryResource(stringTable.collection.totalLicense, null)
        ctx.set('total', result['total'])
        ctx.body = result['result']
    } catch (err) {
        ctx.throw(400)
    }
    dbg_console_res(ctx, null)
})

let resp_cpe_405 = ctx => {
    console.log('resp_cpe_405 ' + ctx.method)
    ctx.set('Allow', 'GET, POST')
    ctx.throw(405)
}
subroute.all(`/${subroutepath}`, resp_cpe_405)

subroute.destruct = () => {
  tpdb.disconnectDb()
}

module.exports = subroute
