'use strict'

const koarouter = require('koa-router')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]

const { agileConfig, stringTable, MongoClass, AgileACSApps, AgileCryptor } = require('tplib')
const tpdb = new MongoClass(agileConfig.get(stringTable.url.dbTplink))

// debug flag
const DBG_CEIP = false

function dbg_console_req(ctx) {
  if (DBG_CEIP) {
    console.log(`Now we are at ${ctx.req.url}`)
    console.log(ctx.method + " " + ctx.path)
    console.log(ctx.request.body)
    console.log(Object.keys(ctx.request.body).length)
  }
}

function dbg_console_res(ctx, cmd) {
  if (DBG_CEIP) {
    if (cmd) console.log('cmd= ' + cmd)
    console.log(ctx.response)
  }
}

subroute.use(require('koa-bodyparser')())

// '/system/syssetting'
subroute.get(`/${subroutepath}`, async ctx => {
  try {
    dbg_console_req(ctx)
    let dbQuery = ctx.query['query'] ? ctx.query['query'] : null
    let result = await tpdb.queryResource(stringTable.collection.syssetting, dbQuery)
    ctx.set('total', result['total'])
    ctx.body = result['result']
    dbg_console_res(ctx, null)
  } catch (err) {
    ctx.throw(400)
  }
})


let resp_syssetting_405 = ctx => {
  console.log('resp_ceip_405 ' + ctx.method)
  ctx.set('Allow', 'GET')
  ctx.throw(405)
}
subroute.all(`/${subroutepath}`, resp_syssetting_405)

subroute.destruct = () => {
  tpdb.disconnectDb()
}

module.exports = subroute
